import bee
from bee.segments import *
import spyder, Spyder
import spyder.formtools
import libcontext

class externblock(object):
  metaguiparams = {"spydertype":"type"}
  def __new__(cls, spydertype):
    assert spyder.validvar2(spydertype), spydertype
    class externblock(bee.worker):
      block_ = antenna("pull", "block")
      b_block = buffer("pull", "block")
      connect(block_, b_block)
      get_block = triggerfunc(b_block)
      
      control = antenna_blockcontrol()

      model = output("pull", "blockmodel")
      v_model = variable("blockmodel")
      connect(v_model, model)
      
      @modifier      
      def _init(self):
        if self._initialized: return
        self.get_block()
        model, controller = self.b_block
        self._controller = controller
        self.v_model = model        
        self._initialized = True
      
      def get_controller(self):
        self._init()
        return self._controller
                        
      def place(self):
        self._initialized = False
        self.control.set_blockcontrol(self.get_controller)

      pretrigger(v_model, _init)
        
    return externblock
      
      
               
  
