import Spyder
import cgi as stdcgi

def subdic(dic, name):
  #Gets a CGI subdict
  if name in dic:
    return True, dic[name]
  ret = {}
  name2 = name + "-"
  for k in dic:
    if k.startswith(name2):
      ret[k[len(name2):]] = dic[k]
  if not len(ret): return None, None
  return False, ret

def tostr(v):
  #Converts a default value to a string representation
  # or: converts a CGI empty string representation to None
  if isinstance(v, str): 
    if v == "": return None
    else: return v
  if v is None: return None    
  if v is True: return True
  if v is False: return False
  
  if isinstance(v, Spyder.File): return v
  try:
    if len(v) == 0: return None
  except (TypeError, AttributeError):
    pass   
  return tostr(str(v))

def list_tostr(lis):
  #Converts a default value list (obtained with SpyderType.list()/.dict())
  # to a string representation list
  ret = []
  for m in lis:
    if isinstance(m, dict):
      mm = dic_tostr(m)
    elif isinstance(m,list) or isinstance(m, tuple):
      mm = list_tostr(m)
    else:
      mm = tostr(m)
    ret.append(mm)
  if ret == [None] * len(lis): ret = None
  return ret
  
def dic_tostr(dic):
  #Converts a default value dict (obtained with SpyderType.dict())
  # to a string representation dict
  if isinstance(dic,list) or isinstance(dic, tuple):
    return list_tostr(dic)
  ret = {}
  for k in dic:
    m = dic[k]
    if isinstance(m, dict):
      mm = dic_tostr(m)
    elif isinstance(m,list) or isinstance(m, tuple):
      mm = list_tostr(m)
    else:
      mm = tostr(m)
    ret[k] = mm
  return ret

def dif_strlist(d1, d2):
  #tests if two string lists (the first from CGI, the second from default value)
  # differ or not
  for v1,v2 in zip(d1,d2):
    if v1 is None: continue
    if isinstance(v1, dict):
      if dif_strdic(v1, v2): return True
    elif isinstance(v1, list):
      if dif_strlist(v1, v2): return True
    else:
      if v1 != v2: return True
  return False
  
def dif_strdic(d1, d2):
  #tests if two string dicts (the first from CGI, the second from default value)
  # differ or not
  for k in d2:
    if k not in d1: continue
    v1,v2 = d1[k], d2[k]
    if v1 is None: continue
    if isinstance(v1, dict):
      if dif_strdic(v1, v2): return True
    elif isinstance(v1, list):
      if dif_strlist(v1, v2): return True
    else:
      if v1 != v2: return True
  return False
        
def cmp_default(dic,typetree,default,arraycount):
  # Compares a CGI dict to default value
  #  returns a tuple of two:
  #   1. are they the same?
  #   2. if so, all elements from the CGI dict that are non-default
  if arraycount > 0:
    if dic is None: return True, None
    ret = []
    is_none = True
    for lnr,l in enumerate(dic):
      try:
        tt = getattr(Spyder, typetree.typename)._typetree()
      except AttributeError:
        tt = None
      mdefault = None
      if default is not None and len(default) > lnr: mdefault = default[lnr]
      same, ll = cmp_default(l, tt, mdefault, arraycount-1)
      ret.append(ll)
      if same == False: is_none = False

    if default is None and typetree is not None: default = typetree.default          
    if is_none:
      ret = None
    else:
      if default is None: return False, ret      
      default_list = list_tostr(default.dict())
      if ret == default_list:
        return True, None
      else:
        return False, ret
    return is_none, ret
      
  if default is None and typetree is not None: default = typetree.default          
  if typetree is None or not typetree.members:     
    if dic is None: return True, None
    v = tostr(dic)    
    str_default = tostr(default)
    if v == str_default:
      return True, None
    else:
      return False, v

  if dic is None: return True, None
  if dic is not None and default is None: return False, dic

  default_dic = dic_tostr(default.dict())
  dif = {}
  for k,tt in typetree.members:
    v = dic.get(k, None)
    if v is None: continue

    d = getattr(default, k)
    dd = None
    if d is not None: dd = default_dic[k]
    
    vv = v
    if isinstance(v, dict):
      if dd is None or dif_strdic(v, dd): dif[k] = v      
    elif isinstance(v, list):
      if dd is None or dif_strlist(v, dd): dif[k] = v  
    else:
      vv = tostr(v)
      if vv != dd: dif[k] = v

  if len(dif) == 0: return True, None
  else: return False, dif
  
  
  
def _cgi(dic, spyderform, prename, is_value, typetree, default):
  """
  Parses a part of a CGI dict
  """
  if default is None: 
    try:
      default = spyderform.default
    except AttributeError:
      pass

  cls = getattr(Spyder, spyderform.typename)
    
  prenam = ""
  if prename is not None: prenam = prename + "-"
  typ = None
  if hasattr(spyderform, "type"):
    t = spyderform.type
    if t == "none": return None
    if t not in ("required", "none"): typ = t
  if typ is None:
    if issubclass(cls, getattr(Spyder, "File")):
      typ = "file"
    if issubclass(cls, getattr(Spyder, "Bool")):
      typ = "checkbox"

  memnames = spyderform.get_membernames()
  if memnames is None or not len(memnames) or typ is not None:
    if spyderform.arraycount > 0:
      assert is_value is not True, (prename, spyderform.typename)
      assert hasattr(spyderform, "length"), (prename, spyderform.typename)
      if dic is None: dic = {}
      ret = []
      allstore = []
      for n in range(spyderform.length):
        name2 = prenam + str(n) 
        is_val, store = subdic(dic, str(n))
        allstore.append(store)
        mdefault = None
        if default is not None and len(default) > n: mdefault = default[n]
        v = _cgi(store, spyderform[n], name2, is_val, spyderform[n]._typetree, mdefault)
        ret.append(v)
      pos = len(ret) - 1
      while pos >= 0 and ret[pos] == None: pos -= 1
      ret = ret[:pos+1]
      if ret == [None] * len(ret): ret = None
      v = ret
      
    else:
      assert is_value is not False, (prename, spyderform.typename)
      v = dic
      if typ == "file":
        filetyp = getattr(Spyder, spyderform.file)
        if not hasattr(spyderform, "filename") or spyderform.filename == None:
          raise TypeError("Cannot parse CGI for %s (%s): spyderform has no attribute 'filename'" % (spyderform.typename, prenam[:-1]))
        if v is not None and len(v):
          v = cls(spyderform.filename, format = filetyp, mode = "w", data=filetyp(v))
        else:
          v = None
      elif typ == "checkbox":
        if v is not None: v = cls(True)
        else: 
          if spyderform.default == True: #explicit False
            v = cls(False)
          else: #implicit False
            v = None
      else:
        if v == "": 
          if spyderform.default is None or str(spyderform.default) == "": #implicit empty string
            v = None
          else: #explicit empty string
            v = cls("")
  else: #composite Spyder object 
    assert is_value is not True, (prename, spyderform.typename)
    if dic is None: dic = {}
    v = {}
    for membername in spyderform.get_membernames():
      name2 = prenam + membername
      member = getattr(spyderform, membername)
      is_val, store = subdic(dic, membername)
      mtt = [e[1] for e in typetree.members if e[0] == membername][0]
      mdefault = None
      if default is not None: mdefault = getattr(default, membername)
      vv = _cgi(store, member, name2, is_val, mtt, mdefault)
      if vv is not None: v[membername] = vv
    if not len(v): v = None
    

  same, dif = cmp_default(v, typetree, default, spyderform.arraycount)
  
  if not (memnames is None or not len(memnames) or typ is not None): #composite Spyder object
    #fix: if we have a default value, but *some* values have been redefined,
    # then add *all* non-redefined default values to the dict
    if dif is not None and default is not None:
      defaultdic = default.dict()
      vv = {}
      vv.update(defaultdic)
      vv.update(dif)
      dif = vv  
  
  return dif
    

def cgi(dic, spyderobj):
  """
  Parses a CGI dict (FieldStorage object, or compatible object with a .getfirst() method)
  The second argument can be a Spyder class, object or form

  Returns a parsed dictionary which can be used to create an object
   using spyderobj.fromdict(...)

  The parsed dictionary does not contain any values that are equal to
    the default values of the Spyder class
  """
  import spyder.modules.core
  from spyder.modules.core import spyderform
  if isinstance(spyderobj, spyderform):
    form = spyderobj
  elif isinstance(spyderobj, Spyder.Object):
    form = spyderobj._form()
  else:
    ok = False
    try: 
      if issubclass(spyderobj, Spyder.Object):
        form = spyderobj._form() 
        ok = True
    except TypeError:
      pass
    if not ok: raise TypeError(spyderobj)
  
  if isinstance(dic, stdcgi.FieldStorage):
    dic2 = {}
    for k in dic:
      dic2[k] = dic.getfirst(k)
    dic = dic2
  return _cgi(dic, form, None, False, form._typetree, None)
