from functools import partial 

def generator_head(name, id, objs, forms, wrappings, name2):
  return "<td>%s</td>" % name2

def generator_hh(index, name, id, objs, forms, wrappings, mode, args):
  if mode != "start": return None
  return '<tr><td class="h%s" colspan=2>%s</td></tr>' % (index, args[0])

def generator_h(index, name, id, objs, forms, wrappings, name2):
  return '<tr><td class="h%s" colspan=2>%s</td></tr>' % (index, name2)

def generator_tr(name, id, objs, forms, wrappings, mode):
  if mode == "start": return "<tr>"
  else: return "</tr>"

def generator_formdata(name, id, objs, forms, wrappings, mode):
  if mode == "start": return "<td class=\"formdata\">"
  else: return "</td>"

def generator_fold_head(name, id, objs, forms, wrappings, name2):
  part1 = '<span id="foldmenu-%s-title" style="float:right"><img src="arrow-down.png" /></span>'
  part2 = '</div><div id="foldmenu-%s" class="switchgroup1"><table>' 
  ret = part1 % id 
  ret += name2
  ret += part2 % id 
  return ret

def generator_fold_wrap(offset, name, id, objs, forms, wrappings, mode):
  level = wrappings + offset
  if level < 1: level = 1
  if level > 5: level = 5
  if mode == "start": 
    ret = '</table><div class="topItem" id="level%s">' % level
  else: 
    ret = '</table></div><table>'
  return ret 

def generator_fold_group(offset, name, id, objs, forms, wrappings, group, groupindex, mode):
  if mode in ("pre", "post"): return None
  if id is None: groupid = "group" + str(groupindex)
  else: groupid = id + "-group" + str(groupindex)
  ret1 = generator_fold_wrap(offset, groupid, groupid, objs, forms, wrappings, mode)
  if mode == "end": 
    return ret1
  
  ret2 = generator_fold_head(name, groupid, objs, forms, wrappings, group)
  return ret1 + ret2

def generator_hr(name, id, objs, forms, wrappings, mode, elegroup):
  stylestr = ""
  if hasattr(elegroup, "style") and elegroup.style is not None:
    stylestr = ' style="%s"' % elegroup.style
  if mode == "start":
    ret = "</table><hr%s /><table>" % stylestr
  elif mode in ("pre", "post"): return None
  elif mode == "end":
    ret = "</table><hr%s /><table>" % stylestr    
  return ret

def generator_textarea(name, id, objs, forms, wrappings, defaultvalue):
  form = forms[0]
  assert hasattr(form, "cols") and form.cols >= 0
  assert hasattr(form, "rows") and form.rows >= 0
  txt = ""
  if defaultvalue is not None: txt = defaultvalue
  t = (id, form.rows, form.cols, id, txt)
  return '<textarea name="%s" rows="%d" cols="%d" id="%s">%s</textarea>' % t
  
  
def init():
  from .htmlform import set_generator, set_element_generator, set_group_generator, set_phase_generator
  set_generator("outerwrap", 0, None)
  set_phase_generator("header", 0, "pre", partial(generator_hh, 2))  
  set_generator("midwrap", 0, generator_tr)
  set_generator("head", 0, generator_head)
  set_generator("group", 0, None) #never triggered
  set_generator("innerwrap", 0, generator_formdata)
  set_group_generator("hr", 0, generator_hr)
  
  set_generator("outerwrap", 1, None)
  set_phase_generator("header",  1, "pre", partial(generator_hh, 2))
  set_generator("midwrap", 1, None)
  set_generator("head", 1, partial(generator_h, 1))
  set_generator("group", 1, None) #never triggered
  set_generator("innerwrap", 1, None)
  set_group_generator("hr", 1, generator_hr)

  for n in range(2,7):
    set_generator("outerwrap", n, partial(generator_fold_wrap, 0))
    set_phase_generator("header", n, "pre", partial(generator_hh, 2))
    set_generator("midwrap", n, None)
    set_generator("head", n, generator_fold_head)
    set_generator("group", n, partial(generator_fold_group, 1))
    set_generator("innerwrap", n, None)
    set_group_generator("hr", n, generator_hr)

  set_element_generator("textarea", generator_textarea)
