from .htmlform import _group_generators, wrappings_regen_min, wrappings_regen_max
def resolve_elegroup(
 elegroup,
 elegroups,
 html,
 t,
 curr_wrappings, 
 done_membernames,
 mhtmls,
 mhtmldata,
 mwrappings,
 curr_membernames,
 curr_members,
 mcomplexities,
 groupindex,
 name,
 n,
 objs,
 forms,
 wrappings,
 complexity,
 gen_group,
):
  g = find_group(elegroups, elegroup.id)
  if g is not None and g.id not in done_membernames:
    #resolve the parent group instead
    return resolve_elegroup(
            g,
            elegroups,
            html,
            t,
            curr_wrappings, 
            done_membernames,
            mhtmls,
            mhtmldata,
            mwrappings,
            curr_membernames,
            curr_members,
            mcomplexities,
            groupindex,
            name,
            n,
            objs,
            forms,
            wrappings,
            complexity,
            gen_group,
           )

  done_membernames.add(elegroup.id)  
  elegroupids = [e.id for e in elegroups]
  gen = _group_generators[elegroup.type, complexity]    
  start = gen(name, n, objs, forms, wrappings, "start", elegroup)
  if start is not None: 
    html.append(t.tabstr + start)
    t.incr()
    curr_wrappings += 1
  for mem in elegroup.members:
    if mem not in curr_membernames and mem not in elegroupids:
      raise Exception("Unknown member %s in group element %s" % (mem, elegroup.id))
    pre = gen(name, n, objs, forms, wrappings, "pre", elegroup)
    if pre is not None: 
      html.append(t.tabstr + pre)
      t.incr()
      curr_wrappings += 1
    while 1:
      if mem in elegroupids:

        g = [e for e in elegroups if e.id == mem][0]
        curr_wrappings, groupindex = resolve_elegroup(
         g,
         elegroups,
         html,
         t,
         curr_wrappings, 
         done_membernames,
         mhtmls,
         mhtmldata,
         mwrappings,
         curr_membernames,
         curr_members,
         mcomplexities,
         groupindex,
         name,
         n,
         objs,
         forms,
         wrappings,
         complexity,
         gen_group,
        )      
        break

      for mhtml, mdat, membername, member, mcomp in \
       zip(mhtmls, mhtmldata, curr_membernames, curr_members, mcomplexities):
        if membername != mem: continue
        curr_wrappings, groupindex = resolve_member(
         membername,
         elegroups,
         html,
         t,
         curr_wrappings, 
         done_membernames,
         mhtmls,
         mhtmldata,
         mwrappings,
         curr_membernames,
         curr_members,
         mcomplexities,
         groupindex,
         name,
         n,
         objs,
         forms,
         wrappings,
         complexity,
         gen_group,
        )
      post = gen(name, n, objs, forms, wrappings, "post", elegroup)
      if post is not None: 
        html.append(post)
        t.decr()
        curr_wrappings -= 1

      break  
  end = gen(name, n, objs, forms, wrappings, "end", elegroup)
  if end is not None: 
    html.append(end)
    t.decr()
    curr_wrappings -= 1

  return curr_wrappings, groupindex    
      

def find_group(elegroups, membername):
  ret = None
  for g in elegroups:
    if membername in g.members: 
      if ret is not None:
        raise Exception("membername %s is a member of multiple group elements" % membername)
      ret = g
  return ret     
  

def resolve_member(
 membername,
 elegroups,
 html,
 t,
 curr_wrappings, 
 done_membernames,
 mhtmls,
 mhtmldata,
 mwrappings,
 curr_membernames,
 curr_members,
 mcomplexities,
 groupindex,
 name,
 n,
 objs,
 forms,
 wrappings,
 complexity,
 gen_group,
):
  from .htmlform import _write_html
  for mhtml, mdat, membername0, member, mcomp in \
   zip(mhtmls, mhtmldata, curr_membernames, curr_members, mcomplexities):
    if membername0 != membername: continue
    if membername in done_membernames: continue
    g = find_group(elegroups, membername)
    if g is not None and g.id not in done_membernames:
      curr_wrappings, groupindex = resolve_elegroup(
       g,
       elegroups,
       html,
       t,
       curr_wrappings, 
       done_membernames,
       mhtmls,
       mhtmldata,
       mwrappings,
       curr_membernames,
       curr_members,
       mcomplexities,
       groupindex,
       name,
       n,
       objs,
       forms,
       wrappings,
       complexity,
       gen_group,
      )      
      continue
    done_membernames.add(membername)
    if mcomp > 1 and curr_wrappings != mwrappings:
      if max(mwrappings, curr_wrappings) >= wrappings_regen_min \
        and min(mwrappings, curr_wrappings) <= wrappings_regen_max:
         #wrapping level has changed, regenerate HTML...
         mobjs, mforms, newprename = mdat
         mhtml, dmmy = _write_html(mobjs, mforms, membername,newprename,curr_wrappings)
    for l in mhtml:
      html.append(t.tabstr + l)
  
  return curr_wrappings, groupindex    
  
def resolve_group(
 group,
 elegroups,
 html,
 t,
 curr_wrappings, 
 done_membernames,
 mhtmls,
 mhtmldata,
 mwrappings,
 curr_membernames,
 curr_members,
 mcomplexities,
 groupindex,
 name,
 n,
 objs,
 forms,
 wrappings,
 complexity,
 gen_group,
):
  groupindex += 1
  start, end = None, None
  if gen_group is not None:
    start = gen_group(name, n, objs, forms, wrappings, group, groupindex, "start")
  if start is not None: 
    html.append(t.tabstr + start)
    t.incr()
    curr_wrappings += 1
  for membername2, member2 in zip(curr_membernames, curr_members):

    if membername2 in done_membernames: continue    
    if hasattr(member2, "group") and member2.group == group:
      if gen_group is not None:
        pre = gen_group(name, n, objs, forms, wrappings, group, groupindex, "pre")
      if pre is not None: 
        html.append(t.tabstr + pre)
        t.incr()
        curr_wrappings += 1

      curr_wrappings, groupindex = resolve_member (
        membername2,
        elegroups,
        html,
        t,
        curr_wrappings, 
        done_membernames,
        mhtmls,
        mhtmldata,
        mwrappings,
        curr_membernames,
        curr_members,
        mcomplexities,
        groupindex,
        name,
        n,
        objs,
        forms,
        wrappings,
        complexity,
        gen_group,
      )
      if gen_group is not None:
        post = gen_group(name, n, objs, forms, wrappings, group, groupindex, "post")
      if post is not None: 
        html.append(t.tabstr + post)
        t.decr()
        curr_wrappings -= 1

  if gen_group is not None:
    end = gen_group(name, n, objs, forms, wrappings, group, groupindex, "end")
  if end is not None: 
    html.append(t.tabstr + end)
    t.decr()
    curr_wrappings -= 1
  
  return curr_wrappings, groupindex

def resolve(
 html,
 t,
 curr_wrappings, 
 done_membernames,
 mhtmls,
 mhtmldata,
 mwrappings,
 curr_membernames,
 curr_members,
 mcomplexities,
 groupindex,
 name,
 n,
 objs,
 forms,
 wrappings,
 complexity,
 gen_group,
):
  form = forms[0]
  elegroups = form._groups
  elegroupmembers = set()
  for e in elegroups:
    for m in e.members: elegroupmembers.add(m)
  for membername, member in zip(curr_membernames, curr_members):
    if hasattr(member, "group") and member.group is not None:
      if membername in elegroupmembers:
        raise Exception("member %s has a .group attribute and is also a member of a group element" % membername)

  for mhtml, membername, member in zip(mhtmls, curr_membernames, curr_members):
    if membername in done_membernames: continue    
    if hasattr(member, "group") and member.group is not None:
      group = member.group
      curr_wrappings, groupindex = resolve_group (
       group,
       elegroups,
       html,
       t,
       curr_wrappings, 
       done_membernames,
       mhtmls,
       mhtmldata,
       mwrappings,
       curr_membernames,
       curr_members,
       mcomplexities,
       groupindex,
       name,
       n,
       objs,
       forms,
       wrappings,
       complexity,
       gen_group,
      )
    else:      
      curr_wrappings, groupindex = resolve_member (
        membername,
        elegroups,
        html,
        t,
        curr_wrappings, 
        done_membernames,
        mhtmls,
        mhtmldata,
        mwrappings,
        curr_membernames,
        curr_members,
        mcomplexities,
        groupindex,
        name,
        n,
        objs,
        forms,
        wrappings,
        complexity,
        gen_group,
      )
    
  """
  for mhtml, membername, member in zip(mhtmls, curr_membernames, curr_members):
    if membername in done_membernames: continue
    if hasattr(member, "group") and member.group is not None:
      groupindex += 1
      group = member.group
      start, end = None, None
      if gen_group is not None:
        start = gen_group(name, n, objs, forms, wrappings, group, groupindex, "start")
      if start is not None: 
        html.append(t.tabstr + start)
      t.incr()
      curr_wrappings += 1
      for mhtml2, mdat, membername2, member2, mcomp2 in \
       zip(mhtmls, mhtmldata, curr_membernames, curr_members, mcomplexities):
        if membername2 in done_membernames: continue
        if not hasattr(member2, "group") or member2.group != group: continue
        done_membernames.add(membername2)
        if mcomp2 > 1 and curr_wrappings != mwrappings:
          if max(mwrappings, curr_wrappings) >= wrappings_regen_min \
            and min(mwrappings, curr_wrappings) <= wrappings_regen_max:
             #wrapping level has changed, regenerate HTML...
             mobjs, mforms, newprename = mdat
             mhtml2, dmmy = _write_html(mobjs, mforms, membername2,newprename,curr_wrappings)
        for l in mhtml2:
          html.append(t.tabstr + l)
      if gen_group is not None:
        end = gen_group(name, n, objs, forms, wrappings, group, groupindex, "end")
      if end is not None: html.append(t.tabstr + end)
      t.decr()
      curr_wrappings -= 1
    else:
      done_membernames.add(membername)
      for l in mhtml:
        html.append(t.tabstr + l)
  """
