# Copyright 2007-2011, Sjoerd de Vries
# This file is part of the Spyder module: "core" 
# For licensing information, see LICENSE.txt 

arraytemplate = """class %(classname)s(spyder.core.spyderlist):  
  @staticmethod  
  def typename(): 
    return "%(classname)s"
  def cast(self, othertype):
    if type(othertype) == type(int): return othertype(self)    
    if hasattr(othertype, "wrapclass"): return othertype.wrapclass(self)
    return globals()[othertype](self)
  def convert(self, target):
    c = Spyder.core.convert(%(classname)s, target, self, globals())
    return c
  def __repr__(self): return self.__print__(0, "repr")
  def repr(self): return self.__print__(0, "repr")
  def validate(self): self.__validate__()
  def __str__(self): return self.__print__(0, "str")
  def str(self): return self.__print__(0, "str")
  def data(self): return str(self)
  def __getattr__(self, method):
    m = spyder.core.method(%(classname)s, method, self)
    return m
  def list(self):
    ret = []
    for v in self:
      ret.append(v.dict())
    return ret
  def dict(self):
    return self.list()
  def __parse__(self, s):
    args = spyder.core.parse(s, "Spyder", True)
    self.__copy__(args[0])
  def __arrayvalidate__(self):
    for v in range(len(self)):
      self[v] = spyder.__types__["%(prevclassname)s"](self[v])
  def __validate__(self):
    self.__arrayvalidate__()
  def __copy__(self,a):
    list.__init__(self, a)
    self.__arrayvalidate__()    
  def __print__(self,spaces,mode):
    ret = "%%s (\\n" %% self.typename()
    for v in self:
      ret += (spaces+2) * " " + v.__print__(spaces+2, mode) + ",\\n"
    ret += spaces * " " +  ")"
    return ret
  def __init__(self, *a):
    if len(a) == 0:
      spyder.core.spyderlist.__init__(self)
      return
    exc = None      
    try:
      if len(a) == 1 and (isinstance(a[0],str) or isinstance(a[0],bytes)): raise Exception
      if len(a) == 1 and issubclass(spyder.__types__["%(prevclassname)s"], spyder.core.spyderlist) and (not isinstance(a[0],list) or not isinstance(a[0][0], spyder.__types__["%(prevclassname)s"])):        
        try:
          self.__copy__(a)
          return
        except:
          pass
      self.__copy__(*a)
    except Exception as e:
      try:
        if isinstance(a,str) or isinstance(a,bytes): 
          e.__context__ = None
          raise
        self.__copy__(a)
      except Exception as e:
        if len(a) > 1: 
          e.__context__ = None
          raise
        try:
          self.__parse__(a[0])
        except Exception as e:
          exc = TypeError("Cannot construct %%s" %% self.typename())
        if exc is None: 
          self.__validate__()
    if exc is not None: raise exc
  @classmethod
  def _typetree(cls): 
    \"\"\"Auto-generated by Spyder:
     module core
     file typetree.py
     function typetree
    Returns the typetree of the Spyder class\"\"\"          
    spyder.core.build_members(cls.typename(),cls)
    return spyder.core.get_typetreedict(cls.typename())
  @classmethod
  def __form__(cls):
    \"\"\"Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Generates the spyderform of the class
     This function is automatically called at class creation\"\"\"
    spyder.core.spyderform(cls._typetree()) 

%(classname)s.fromlist = %(classname)s
%(classname)s.fromdict = %(classname)s
spyder.core.defineconverter("%(prevclassname)s","%(classname)s","CAST")
spyder.core.defineconverter("%(classname)s","%(prevclassname)s","SPLIT")
"""

corearraycode = """
for n in range(spyder.arraymax):
  classname = %(typename)s + (n+1) * "Array"
  prevclassname = %(typename)s + n * "Array"
  d = dict(typename=%(typename)s, classname=classname, prevclassname=prevclassname)
  defcode = spyder.core.arraytemplate %% d
  obj = compile(defcode, classname,'exec')
  import linecache
  linecache.cache[classname] = None,None,defcode.splitlines(),%(typename)s
  exec(obj)
  if classname not in globals():
    globals()[classname] = locals()[classname]
  spyder.__types__[classname] = globals()[classname]
  globaldict[classname] = globals()[classname]
"""

def arrayfunc(typename, globaldict):
  code = corearraycode % dict(typename= '"' + typename + '"')
  obj = compile(code, typename+"-arraycode",'exec')
  import linecache
  linecache.cache[typename+"-arraycode"] = None,None,code.splitlines(),typename
  exec(obj)
  

