# Copyright 2007-2011, Sjoerd de Vries
# This file is part of the Spyder module: "core" 
# For licensing information, see LICENSE.txt 
 
def generate_construct(typename, parentnames, source, members, deleted_members, block):
  if len(members) == 0: return None,None
  requiredmembers, defaultmembers, optionalmembers, args, allargs = spyder.core.parse_members(typename,members,None, spyder.safe_eval)

  s =  """  def __construct__ (self, %s):
    \"\"\"Auto-generated by Spyder:
     module core
     file construct.py
     function generate_construct
    General private constructor, for internal use only\"\"\" 
    if self.__constructor__ == self.__defaultconstructor__:
      def reconstruct(classtype, var):
        return classtype(var)
      reconstruct_default = reconstruct  
    else:
       def reconstruct_default(classtype, var):
         return classtype(var)    
       def reconstruct(classtype, var):         
         classtype.__constructor__ = self.__constructor__
         try:
           ret = classtype(var)
         finally:  
           classtype.__constructor__ = self.__defaultconstructor__
         return ret         
""" % allargs
  for m in requiredmembers:
      s += "    try:\n"
      s += "      self.%s = reconstruct(%s,%s)\n" % (m[1], m[0], m[1])
      s += "    except AssertionError as exc: exc.__context__ = None; raise\n"
      s += "    except Exception as err:\n"
      s += "      err.__context__ = None; raise err.__class__(\"Member '%s':\\n  \" + str(err))\n" % m[1]
  for mnr, m in enumerate(defaultmembers):
    if m[1] in optionalmembers:
      s += "    self.%s = None\n" % (m[1])
      s += "    try:\n"
      s += "      if %s != None: self.%s = reconstruct(%s,%s)\n" % (m[1], m[1], m[0], m[1])
      s += "    except AssertionError as exc: exc.__context__ = None; raise\n"
      s += "    except Exception as err:\n"
      s += "      err.__context__ = None; raise err.__class__(\"Member '%s':\\n  \" + str(err))\n" % m[1]
    else:
      s += "    reconstruct_func = reconstruct \n"
      s += "    default0 = self.__unpack__.__defaults__[%d] if (sys.version_info[0] == 3) else self.__unpack__.func_defaults[%d]\n" % (mnr, mnr)
      s += "    if %s is default0 or (%s.__class__ is default0.__class__ and %s == default0):" % (m[1], m[1], m[1])      
      s += "      reconstruct_func = reconstruct_default\n" 
      s += "    try:\n"
      s += "      self.%s = reconstruct_func(%s,%s)\n" % (m[1],  m[0],m[1])
      s += "    except AssertionError as exc: exc.__context__ = None; raise\n"
      s += "    except Exception as err:\n"
      s += "      err.__context__ = None; raise err.__class__(\"Member '%s':\\n  \" + str(err))\n" % m[1]

  if len(members) == 0: s += "    pass\n"
  return s, None
  
spyder.defineunimethod("__construct__", generate_construct)
