# Copyright 2007-2012, Sjoerd de Vries
# This file is part of the Spyder module: "core" 
# For licensing information, see LICENSE.txt 

def generate_length(typename, parentnames, source, members, deleted_members, block):
  if len(members) == 0: return None,None 
  requiredmembers, defaultmembers, optionalmembers, args, allargs = spyder.core.parse_members(typename,members,None, spyder.safe_eval)
 
  s = ""
  if block != None:
    s = """  def length(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file length.py
     function generate_length
    Return the length of the current object
    This is automatically defined for arrays,
     but must be defined in the length block for other types\"\"\"
"""
    ss = ""
    for m in requiredmembers:
      ss += "    %s = self.%s\n" % (m[1],m[1])
    for m in defaultmembers:
      ss += "    %s = self.%s\n" % (m[1],m[1])      
    spaces = -1
    for l in block.split('\n'):
      if len(l.strip()) == 0: continue
      if spaces == -1:
        spaces = len(l) - len(l.lstrip())
        s += ss
      s += "    %s\n" % l[spaces:]    
    if spaces == -1: s += "    pass\n"
  return s,None

def generate_len(typename, parentnames, source, members, deleted_members, block):
  if len(members) == 0: return None,None  
  if block != None: raise Exception
  s = """  def __len__(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file length.py
     function generate_len
    Return the length of the current object
    len(self) triggers this function, which redirects to self.length()\"\"\"
"""
  s += "    return self.length()\n"
  return s,None

spyder.defineunimethod("length", generate_length)
spyder.defineunimethod("__len__", generate_len)
