
import functools
class Stream(Object):
  """Spyder-generated class

 module spyder.modules.builtin
 file 'Stream.spy'

Class representing the input/output of a UNIX pipe
   "out" contains the data received from stdout / sent to stdin
   "err" contains the data received from stderr
  If "err" is empty, only "out" is printed by a "print" statement
  
----------------------------------------------------------------------
Spyder definition:

Type Stream {
  #!#!#!
  Class representing the input/output of a UNIX pipe
   "out" contains the data received from stdout / sent to stdin
   "err" contains the data received from stderr
  If "err" is empty, only "out" is printed by a "print" statement
  #!#!#!
  *Data out
  *Data err
  validate {
    if out is not None and len(out) == 0: self.out = None
    if err is not None and len(err) == 0: self.err = None
  }
  def pipe(self, cmd):
  def __or__(self, cmd):
  def join(self):
  def swap(self):
  def chomp(self):
  def lines(self):
  def textdata(self):
  def data(self):
  def text(self): 
  def __str__(self):
}

----------------------------------------------------------------------
"""

  __multimethods = {} #Auto-generated by Spyder
  
  multimethod = functools.partial(spyder.core.__multimethod__,__multimethods) #Auto-generated by Spyder
    
  @staticmethod
  def typename():
    """Auto-generated by Spyder:
     module core
     file class.py
     function generate_class
    Return the class name of the current object"""
    return "Stream"
  def cast(self, othertype):
    """Auto-generated by Spyder:
     module core
     file class.py
     function generate_class
    Return an object of the type "othertype" initialized from this object"""
    if type(othertype) == type(int): return othertype(self)    
    if hasattr(othertype, "wrapclass"): return othertype.wrapclass(self)
    return globals()[othertype](self)

  __constructor__ = "constructor_fromany" #Auto-generated by Spyder
  __defaultconstructor__ = __constructor__ #Auto-generated by Spyder
  def constructor_empty(self):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Empty constructor, all members must be assigned manually afterwards"""    
  def constructor_fromlist(self, *args, **args2):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    List constructor"""        
    a = self.__unpack__(*args[0])
    self.__construct__ (*a)
  def constructor_fromdict(self, dic):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Dict constructor"""       
    if isinstance(dic, dict) and "_ghostfile" in dic:   
      f = spyder.core.newnamespace()
      f.filename = dic["_ghostfile"][1:-1]
      self._ghostparam = [f, f]
      def getobj(obj):
        return obj                
      self.__dict__ = {"__print__":self._ghost__print__, "__str__":self.__str__, "__repr__": self.__repr__}      
      for k in dir(type(self)):
        if k == "__getattr__" or k in self.__dict__: continue
        self.__dict__[k] = functools.partial(self.__getattr__, k)   
      return                  
    a = self.__copydict__(dic)
    self.__construct__ (*a)              
 
  def __init__(self,*args, **args2):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Init function, calls the general constructor (fromany by default)"""            
    self.Annotation = {}
    for funcname in self.__multimethods:
      func, arg = self.__multimethods[funcname]
      self.__dict__[funcname] = functools.partial(func, **({arg:self}))    
    return Stream.__dict__[Stream.__constructor__](self, *args, **args2)
  def constructor_fromany(self,*args, **args2):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    General constructor for the current class
    This function tries five specialized constructors in this order:
    - Copy constructor
    - Dict constructor
    - Value/Keyword constructor
    - Parsing constructor
    - List constructor
    For more information, see the Spyder documentation"""

    raise_exc = None
    try:
      exc = "An error has occurred in the construction of a Stream object"
      exc += "\nNumber of arguments: value %d, keyword %d\n" % (len(args), len(args2))
      try:
        construct = -1
        try:
          if len(args) > 1 or len(args2) > 0: raise IndexError
          a = self.__copy__(args[0]) #func(func(a,b,c))
        except AssertionError as e: 
          e.__context__ = None
          raise
        except Exception as e:
          if len(args) > 1 or len(args2) > 0: raise IndexError
          exc += "\n*** (Stream) Copy constructor ***\n"+ spyder.exception()
          e.__context__ = None
          try:
            a = self.__copydict__(args[0]) #func({a:1,b:2,c:3})
          except Exception as e:          
            exc += "\n*** (Stream) Dict constructor ***\n"+ spyder.exception()
            e.__context__ = None
            raise
          else:
            construct = 2
        else:
          construct = 1              
        self.__construct__ (*a)
      except AssertionError as e: 
        e.__context__ = None
        raise
      except Exception as e:
        e.__context__ = None
        if not (len(args) > 1 or len(args2) > 0):
          if construct == 1: exc += "\n*** Copy constructor (Stream) ***\n" + spyder.exception()
          if construct == 2: exc += "\n*** Dict constructor (Stream) ***\n" + spyder.exception()
        try:
          if len(args) == 1 and len(args2) == 0 and isinstance(args[0], str):
            if args[0].startswith("Stream") and args[0][len("Stream"):].lstrip()[0] == "(":
              raise TypeError
          a = self.__unpack__(*args, **args2) #func(a,b,c)
          self.__construct__ (*a) ##
        except AssertionError as e: 
          e.__context__ = None
          raise
        except Exception as e:
          exc += "\n*** (Stream) Value/Keyword constructor ***\n" + spyder.exception()
          e.__context__ = None
          if len(args) > 1 or len(args2) > 0 : raise          
          try:
            a = self.__parse__(args[0]) #func("[a,b,c]")
            if a == None: return
            self.__construct__ (*a)
          except AssertionError as e: 
            e.__context__ = None
            raise
          except Exception as e:
            exc += "\n*** (Stream) Parsing constructor ***\n" + spyder.exception()
            e.__context__ = None
            try:
              a = self.__unpack__(*args[0]) #func([a,b,c])
              self.__construct__ (*a)
            except Exception as e:
              exc += "\n*** (Stream) List constructor ***\n" + spyder.exception()
              e.__context__ = None
              raise
      exc = "" 
      self.validate()
    except AssertionError: raise
    except Exception as err:
      if len(str(err).strip().strip('\n')) == 0: raise
      else: raise_exc = type(err)(exc+'\n'+str(err))
    if raise_exc: raise raise_exc  

  @classmethod
  def _typetree(cls): 
    """Auto-generated by Spyder:
     module core
     file typetree.py
     function typetree
    Returns the typetree of the Spyder class"""          
    spyder.core.build_members(cls.typename(),cls)
    return spyder.core.get_typetreedict(cls.typename())
  def __construct__ (self, out,err):
    """Auto-generated by Spyder:
     module core
     file construct.py
     function generate_construct
    General private constructor, for internal use only""" 
    if self.__constructor__ == self.__defaultconstructor__:
      def reconstruct(classtype, var):
        return classtype(var)
      reconstruct_default = reconstruct  
    else:
       def reconstruct_default(classtype, var):
         return classtype(var)    
       def reconstruct(classtype, var):         
         classtype.__constructor__ = self.__constructor__
         try:
           ret = classtype(var)
         finally:  
           classtype.__constructor__ = self.__defaultconstructor__
         return ret         
    self.out = None
    try:
      if out != None: self.out = reconstruct(Data,out)
    except AssertionError as exc: exc.__context__ = None; raise
    except Exception as err:
      err.__context__ = None; raise err.__class__("Member 'out':\n  " + str(err))
    self.err = None
    try:
      if err != None: self.err = reconstruct(Data,err)
    except AssertionError as exc: exc.__context__ = None; raise
    except Exception as err:
      err.__context__ = None; raise err.__class__("Member 'err':\n  " + str(err))
  def __unpack__(self,out=None,err=None,*_bogusargs, **_boguskwargs): 
    """Auto-generated by Spyder:
     module core
     file unpack.py
     function generate_unpack
    Private list/value/keyword constructor, for internal use only"""
    return out,err
  def __copy__(self,_a):
    """Auto-generated by Spyder:
     module core
     file copy.py
     function generate_copy
    Private copy constructor, for internal use only"""
    ok = (_a == None or isinstance(_a,Stream))
    out = None
    if hasattr(_a,"out") and _a.out != None:
      ok = True
      out = _a.out
    err = None
    if hasattr(_a,"err") and _a.err != None:
      ok = True
      err = _a.err
    if ok == False: raise AttributeError
    if hasattr(_a, "__conversionstack__"): self.__conversionstack__ = _a.__conversionstack__
    self.Annotation = {}
    if hasattr(_a,"Annotation"): self.Annotation = _a.Annotation
    return (out,err,)
  def __copydict__(self,_a):
    """Auto-generated by Spyder:
     module core
     file copy.py
     function generate_copydict
    Private dict constructor, for internal use only"""
    ok = (_a == None or isinstance(_a, dict))
    out = None
    if "out" in _a:
      ok = True
      out = _a["out"]
    if isinstance(_a, dict) and "out" in _a: out = _a["out"]
    err = None
    if "err" in _a:
      ok = True
      err = _a["err"]
    if isinstance(_a, dict) and "err" in _a: err = _a["err"]
    if ok == False: raise AttributeError
    return (out,err,)
  def validate(self):
    """Auto-generated by Spyder:
     module core
     file validate.py
     function generate_validate
    Validates the current object
    This is automatically called after construction
    It is NOT automatically called after editing the object"""
    try:
      pass
      self.__validate__()
    except Exception as inst: 
      if isinstance(inst, AssertionError):
        raise 
      else:
        #TODO; import sys
        #tb = sys.exc_info()[2]      
        #e = spyder.core.ValidationError
        #raise e, e(str(inst)), tb #TODO
        raise spyder.core.ValidationError(str(inst))
  def __validate__(self):
    """Auto-generated by Spyder:
     module core
     file validate.py
     function generate_intern_validate
    Private object validator, for internal use only"""
    out = self.out
    err = self.err
    if out is not None and len(out) == 0: self.out = None
    if err is not None and len(err) == 0: self.err = None
  def __len__(self):
    """Auto-generated by Spyder:
     module core
     file length.py
     function generate_len
    Return the length of the current object
    len(self) triggers this function, which redirects to self.length()"""
    return self.length()
  def __str__(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    This function is triggered by the print statement
    Redirects to self.__print__"""
    return self.__print__(0, "str")
  def str(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    Redirects to self.__print__"""
    return self.__print__(0, "str")
  def data(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    Redirects to self.__print__"""
    return self.__print__(0, "str")
  def repr(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_repr
    Converts the current object to a representation string
    As a side effect, saves all files within the object
    Redirects to self.__print__"""
    return self.__print__(0, "repr")
  def __repr__(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_repr
    Converts the current object to a representation string
    As a side effect, saves all files within the object
    Redirects to self.__print__"""
    return self.__print__(0, "repr")
  def __print__(self,spaces,mode):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_print
    Pretty-prints the current object, for internal use only
    Redirects to self.__print__"""
    ret = "%s (\n" % self.typename() 
    v = self.out
    if v != None:
      if type(v) != Data: v = Data(v)
      ret += "%sout = " % ((spaces+2) * " ") + v.__print__(spaces+2, mode) + ",\n"
    v = self.err
    if v != None:
      if type(v) != Data: v = Data(v)
      ret += "%serr = " % ((spaces+2) * " ") + v.__print__(spaces+2, mode) + ",\n"
    ret += "%s)" % (spaces * " ")
    return ret
  def dict(self):
    """Auto-generated by Spyder:
     module core
     file dict.py
     function generate_dict
    Converts the current object to a Python dictionary"""
    _d = {}
    v = self.out
    if v != None:
      if type(v) != Data: v = Data(v)
      _d["out"] = v.dict()
    v = self.err
    if v != None:
      if type(v) != Data: v = Data(v)
      _d["err"] = v.dict()
    return _d
  def __parse__(self, s):
    """Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse
    Parsing constructor, which redirects to spyder.core.parse"""
    p = spyder.core.parse(s, "Spyder", True)
    if type(p) == type(self):
      self.__dict__ = p.__dict__
      return None       
    try:
      a = self.__unpack__(*p[0], **p[1])
    except:
      try:
        a = self.__copy__(p)
      except:
        a = self.__copydict__(p)
    return a
  @classmethod
  def fromfile(c, filename, fastparse=False):
    """Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse   
    fromfile constructor"""
    import os, traceback
    n = os.linesep
    if fastparse: 
      ret = spyder.core.fastparse(filename, c)
    else: 
      exc = "An error has occurred in the parsing of a " + c.typename() +  " object" 
      exc += n + "Filename: " + filename
      traces = n + "*** Tracebacks ***" + n
      try:
        try: #first attempt a parsing read, does not work with all data models
          data = spyder.core.parse(spyder.loader.file_load(filename).read())                
          ret = c.fromdict(data[1])
        except Exception as e: 
          head = n + "### Core parser ###" + n 
          exc += head + spyder.exception()
          traces += head
          traces += traceback.format_exc(e) + n
          e.__context__ = None      
          raise
      except Exception as e: 
        try: #read using File, also works with web links
          try:
            ret = spyder.__types__["File"](filename, c).data()
          except Exception as e:
            head = n + "### Spyder.File parser ###" + n 
            exc += head + spyder.exception()
            traces += head            
            traces += traceback.format_exc(e) + n
            e.__context__ = None
            raise                  
        except Exception as e:
          raise type(e)(exc + n + traces)
    return ret
  def tofile(self, filename):
    """Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse      
    Saves object to file"""
    f = spyder.__types__["File"](filename, type(self), "w", self)
    f.save()
    f.close()
  def totempfile(self):
    """Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse      
    Saves object to temporary file"""
    import random, os,tempfile
    tempdir = tempfile.gettempdir()
    while 1:
      tempnam = tempdir + os.sep + str(random.randrange(1,1000000000)) +".tmp"
      if not spyder.loader.file_exists(tempnam): break
    f = spyder.__types__["File"](tempnam, type(self), "w", self)
    f.temporary(True)
    f.save()
    return f
  def __getattr__(self, method):
    """Auto-generated by Spyder:
     module core
     file convert.py
     function generate_getattr
    Invokes the conversion engine """    
    m = spyder.core.method(Stream, method, self)
    return m
  def convert(self, target,deepcopy=True):
    """Auto-generated by Spyder: 
     module core
     file convert.py
     function generate_convert
    Convert current object into type "target" """
    c = spyder.core.convert(Stream, target, self, deepcopy)
    return c
  def threadconvert(self, target, deepcopy=True):
    """Auto-generated by Spyder:
     module core
     file convert.py
     function generate_convert
    Asynchronously convert current object into type "target"
    Immediately returns a waiting handle to the result
    Use spyder.core.thread.wait_all(<list of handles>)
     or spyder.core.thread.wait_any(<list of handles>)
     to wait for the result
    """
    c = spyder.core.spyderthread.threadstart (
     spyder.core.convert, (Stream, target, self, deepcopy),
     name="Stream=>%s" % target.typename(), 
    )
    return c
  
  def __ne__(self,_a): return not self.__eq__(_a)
  def __eq__(self,_a):
    """Auto-generated by Spyder:
     module core
     file eq.py
     function generate_eq
    Comparison operator"""
    try:
      if not isinstance(_a,Stream) and not isinstance(self, type(_a)): return False
    except (TypeError, AttributeError, spyder.core.ValidationError): return False
    if _a is self: return True
    if self.out != _a.out: return False
    if self.err != _a.err: return False
    return True
  
  @classmethod
  def _form(cls):
    """Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Returns the spyderform of the class
     This function is automatically called at class creation"""
    return spyder.core.spyderforms[cls.typename()]
  @classmethod
  def __form__(cls):
    """Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Generates the spyderform of the class
     This function is automatically called at class creation"""
    self = spyder.core.spyderform(cls._typetree())
  def pipe(self, cmd):
    """Opens a pipe to system command cmd
    self.out is sent to the pipe's stdin
    Returns a Stream containing 
       the pipe's stdout in out 
       and self.err + the pipe's stderr in err
    """
    err = self.err
    if self.out is None: 
      s = Stream(*pipe(cmd))
    else:
      s = Stream(*pipe(cmd, self.out.data()))
    serr = s.err
    if err is None:
      cerr = None
      if serr is not None: cerr = serr.data()
    else:
      cerr = err.data()    
      if serr is not None: cerr += serr.data()
    return Stream(s.out, cerr)
  def __or__(self, cmd):
    """Pipe operator | ; equivalent to self.pipe(...)"""
    return self.pipe(cmd)
  def join(self):
    """Adds self.err to self.out"""
    ret = Stream(self)
    if ret.err is not None:
      if ret.out is None: ret.out = ret.err
      else: ret.out = Data(ret.out.data() + ret.err.data())
      ret.err = None
    return ret
  def swap(self):
    """Swaps self.out and self.err"""
    return Stream(self.err, self.out)
  def chomp(self):
    """Removes trailing EOL of self.out and self.err"""
    if self.out != None and self.out.data().endswith('\n'):
      self.out = Data(self.out.data()[:-len('\n')])
    if self.err != None and self.err.data().endswith('\n'):
      self.err = Data(self.err.data()[:-len('\n')])     
    return self
  def lines(self):
    """Splits self.out into lines"""
    if self.out == None: return []
    d = self.out.data()
    if d.endswith('\n'): d = d[:-len('\n')]
    return d.split('\n')
  def textdata(self):
    """Returns self.out.textdata()"""
    if self.out == None: return ""
    return self.out.textdata()
  def data(self):
    """Returns self.out.data()"""
    if self.out == None: return ""
    return self.out.data()    
  def text(self): 
    """Returns self.out.textdata()"""
    return self.textdata()
  def __str__(self):
    """if self.err is None, this is equivalent to str(self.out)"""
    if self.out is None and self.err is None: return ""
    if self.err is None: 
      return self.out.textdata()
    if self.out is None:
      return "Stream (\n  err = '%s',\n)" % (self.err.textdata())
    return "Stream (\n  out = '%s',\n  err = '%s',\n)" % (self.out.textdata(), self.err.textdata())
spyder.__types__["Stream"] = Stream
Stream._requiredmembers = []
Stream._defaultmembers = [['Data', 'out', 'None', 1], ['Data', 'err', 'None', 2]]
Stream.__form__()

Stream.empty = functools.partial(spyder.__constructor, 
  "constructor_empty",
  Stream,
  "constructor_fromany",
)
Stream.fromlist = functools.partial(spyder.__constructor, 
  "constructor_fromlist",
  Stream,
  "constructor_fromany",
)
Stream.fromdict = functools.partial(spyder.__constructor, 
  "constructor_fromdict",
  Stream,
  "constructor_fromany",
)
for n in range(spyder.arraymax):
  classname = "Stream" + (n+1) * "Array"
  prevclassname = "Stream" + n * "Array"
  d = dict(typename="Stream", classname=classname, prevclassname=prevclassname)
  defcode = 'class %s(spyder.core.spyderlist):\n' % classname
  defcode += '  @staticmethod\n  def typename(): return "%s"\n' % classname
  defcode += """  def cast(self, othertype):
    if type(othertype) == type: return othertype(self)
    return globals()[othertype](self)
"""
  defcode += """  def __arrayvalidate__(self):
    if self.__constructor__ == self.__defaultconstructor__:
      def reconstruct(classtype, var):
        return classtype(var)
    else:
       def reconstruct(classtype, var):         
         classtype.__constructor__ = self.__constructor__
         try:
           ret = classtype(var)
         finally:
           classtype.__constructor__ = self.__defaultconstructor__
         return ret               
    for v in range(len(self)):
      self[v] = reconstruct(%(prevclassname)s,self[v])
  def __validate__(self):
    try:
      self.__arrayvalidate__()
    except Exception as inst:
      if isinstance(inst, AssertionError):
        raise 
      else: raise spyder.core.ValidationError(str(inst))
\n""" % d
  defcode += """
  @classmethod
  def _typetree(cls): 
    \"\"\"Auto-generated by Spyder:
     module core
     file typetree.py
     function typetree
    Returns the typetree of the Spyder class\"\"\"          
    spyder.core.build_members(cls.typename(),cls)
    return spyder.core.get_typetreedict(cls.typename())
\n""" % d
  defcode += """  def __getattr__(self, method):    
      m = spyder.core.method(%(classname)s, method, self)
      return m
\n""" % d
  defcode += """  
  @classmethod
  def _form(cls):
    \"\"\"Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Returns the spyderform of the class
     This function is automatically called at class creation\"\"\"
    return spyder.core.spyderforms[cls.typename()]
  @classmethod
  def __form__(cls):
    \"\"\"Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Generates the spyderform of the class
     This function is automatically called at class creation\"\"\"
    spyder.core.spyderform(cls._typetree()) 
    t = cls.typename()
    while t.endswith("Array"): t = t[:-len("Array")]
    spyder.core.spyderforms[cls.typename()]._members = spyder.core.spyderforms[t]._members
\n""" % d
  defcode += """  def __str__(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    This function is triggered by the print statement
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "str")
  def str(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "str")
  def data(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "str")
\n""" % d
  defcode += """  def validate(self): self.__validate__()
\n""" % d
  defcode += """  def __print__(self,spaces,mode):
    ret = "%%s (\\n" %% self.typename()
    for v in self:
      ret += (spaces+2) * " " + v.__print__(spaces+2, mode) + ",\\n"
    ret += spaces * " " +  ")"
    return ret\n""" % d
  defcode += """  def __ne__(self,_a): return not self.__eq__(_a)
  def __eq__(self,_a):
    \"\"\"Auto-generated by Spyder:
     module core
     file eq.py
     function generate_eq
    Comparison operator\"\"\"
    if not isinstance(_a, %(classname)s) and not isinstance(self, type(_a)): return False
    if _a is self: return True
    if len(self) != len(_a): return False
    for n,nn in zip(self,_a):
      if n != nn: return False
    return True
\n""" % d
  defcode += """
  __constructor__ = "constructor_fromany"
  __defaultconstructor__ = __constructor__
  def constructor_empty(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Empty constructor, all members must be assigned manually afterwards\"\"\"
  def constructor_fromlist(self, *a):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    List constructor\"\"\"    
    list.__init__(self, *a)
    self.validate()
  def constructor_fromdict(self, *a):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Dict constructor\"\"\"    
    list.__init__(self, *a)
    self.validate()      
  
  def __init__(self,*a, **args2):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Init function, calls the general constructor (fromany by default)\"\"\"
    if len(args2.keys()): raise Exception          
    self.Annotation = {}
    return %(classname)s.__dict__[%(classname)s.__constructor__](self, *a)  
  def constructor_fromany(self, *a):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    General constructor for arrays\"\"\"    
    if len(a) == 0:
      spyder.core.spyderlist.__init__(self)
      return
    try:
      if len(a) == 1 and isinstance(a[0],str): raise Exception
      self.__copy__(*a)
    except AssertionError: raise
    except:
      try:
        if isinstance(a,str): raise Exception
        self.__copy__(a)      
      except AssertionError: raise
      except:
        if len(a) > 1: raise
        self.__parse__(a[0])
\n""" % d
  defcode += """  def __copy__(self,a):
    list.__init__(self, a)
    if hasattr(a, "__conversionstack__"): self.__conversionstack__ = a.__conversionstack__
    self.Annotation = {}
    if hasattr(a,"Annotation"): self.Annotation = a.Annotation
    self.__arrayvalidate__()      
 \n""" % d
  defcode += """  def convert(self, target,deepcopy=True):
    c = spyder.core.convert(%(classname)s, target, self, deepcopy)
    return c
  def threadconvert(self, target,deepcopy=True):
    c = spyder.core.spyderthread.threadstart (
     spyder.core.convert, (%(classname)s, target, self,deepcopy),
     name="%(classname)s=>%%s" %% target.typename(), 
    )
    return c    
\n""" % d
  defcode += """  
  def list(self):
    ret = []
    for vnr in range(len(self)):
      if type(self[vnr]) != Stream: self[vnr] = Stream(self[vnr])
      ret.append(self[vnr].dict())
    return ret  
  
  def dict(self):
    return self.list()
\n""" % d
  defcode += """  def __parse__(self, s):
    \"\"\"Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse   
    Parsing constructor, which redirects to spyder.core.parse\"\"\"
    args = spyder.core.parse(s, "Spyder", True)
    self.__copy__(args[0])
  @classmethod
  def fromfile(c, filename, fastparse=False):
    \"\"\"Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse   
    fromfile constructor\"\"\"
    import os, traceback
    n = os.linesep
    if fastparse: 
      ret = spyder.core.fastparse(filename, c)
    else: 
      exc = "An error has occurred in the parsing of a " + c.typename() +  " object" 
      exc += n + "Filename: " + filename
      traces = n + "*** Tracebacks ***" + n
      try:
        try: #first attempt a parsing read, does not work with all data models
          data = spyder.core.parse(spyder.loader.file_load(filename).read())                
          ret = c.fromdict(data[1])
        except Exception as e: 
          head = n + "### Core parser ###" + n 
          exc += head + spyder.exception()
          traces += head
          traces += traceback.format_exc(e) + n
          e.__context__ = None      
          raise
      except Exception as e: 
        try: #read using File, also works with web links
          try:
            ret = spyder.__types__["File"](filename, c).data()
          except Exception as e:
            head = n + "### Spyder.File parser ###" + n 
            exc += head + spyder.exception()
            traces += head            
            traces += traceback.format_exc(e) + n
            e.__context__ = None
            raise                  
        except Exception as e:
          raise type(e)(exc + n + traces)
    return ret
  def tofile(self, filename):
    \"\"\"Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse      
    Saves object to file\"\"\"
    f = spyder.__types__["File"](filename, type(self), "w", self)
    f.save()
    f.close()
  def totempfile(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse      
    Saves object to temporary file\"\"\"
    import random, os,tempfile
    tempdir = tempfile.gettempdir()
    while 1:
      tempnam = tempdir + os.sep + str(random.randrange(1,1000000000)) +".tmp"
      if not spyder.loader.file_exists(tempnam): break
    f = spyder.__types__["File"](tempnam, type(self), "w", self)
    f.temporary(True)
    f.save()
    return f
\n""" % d
  defcode += """  def repr(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_repr
    Converts the current object to a representation string
    As a side effect, saves all files within the object
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "repr")
  def __repr__(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_repr
    Converts the current object to a representation string
    As a side effect, saves all files within the object
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "repr")
\n""" % d
  defcode += "spyder.core.defineconverter(\"%(classname)s\",\"%(prevclassname)s\",\"SPLIT\")\n" % d
  defcode += "spyder.core.defineconverter(\"%(prevclassname)s\",\"%(classname)s\",\"CAST\")\n" % d
  exec(defcode)
  spyder.__types__[classname] = globals()[classname]

  arrayclass = spyder.__types__[classname]
  arrayclass.empty = functools.partial(spyder.__constructor, 
   "constructor_empty",
   arrayclass,
   "constructor_fromany",
  )
  arrayclass.fromlist = functools.partial(spyder.__constructor, 
   "constructor_fromlist",
   arrayclass,
   "constructor_fromany",
  )
  arrayclass.fromdict = functools.partial(spyder.__constructor, 
   "constructor_fromdict",
   arrayclass,
   "constructor_fromany",
  )
  arrayclass.__form__()

