
import functools
class RubikSnake(ThreeDee,EThreeDee):
  """Spyder-generated class

 module spyder.modules.models3d
 file 'rubiksnake.spy'

Representation of Rubik's Snake as an array of turns
    where 0 means no turn, 
     1 a 45 degree right turn, 
     2 a 90 degree turn 
     and 3 a 45 degree left turn
    There is always one more segment than there is turns
    Unlike the traditional Rubik's Snake (23 turns)
     the snake can have any length
    Upon construction, the snake is validated for clashes
  
----------------------------------------------------------------------
Spyder definition:

Type RubikSnake(ThreeDee,EThreeDee) {
  #!#!#!
  Representation of Rubik's Snake as an array of turns
    where 0 means no turn, 
     1 a 45 degree right turn, 
     2 a 90 degree turn 
     and 3 a 45 degree left turn
    There is always one more segment than there is turns
    Unlike the traditional Rubik's Snake (23 turns)
     the snake can have any length
    Upon construction, the snake is validated for clashes
  #!#!#!
  IntegerArray turns = (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
  Float size #the size of each segment
  AxisSystem axis = AxisSystem()
  form {
    self.matrix = "axis"
    size.default = 1
    size.range = 1
    turns[None].min = -1
    turns[None].max = 4
    turns[None].default = 0
  }  
  validate {
    for t in turns:
      assert t in range(0,4)
    dir1,dir2,dir3 = 1,3,5
    posx,posy,posz = 0,0,0
    positions = {}
    positions[(posx,posy,posz)] = (dir1,dir2)
    for t in turns:
      posx,posy,posz = rubiksnakecode.move(posx,posy,posz,dir1)
      dir1,dir2,dir3 = rubiksnakecode.turn(dir1,dir2,dir3,t)
      if (posx,posy,posz) in positions:
        opposite = rubiksnakecode.get_opposite(positions[(posx,posy,posz)])
        if dir1 != opposite[0] or dir2 != opposite[1]: 
          raise ValidationError("Clash detected")
      positions[(posx,posy,posz)] = (dir1,dir2)
  }
  def blenderevent(self,blenderdata,currobj,currobjtype,currblenderdata,signalhead,signal,event=None,eventval=None,handles=None):
}

----------------------------------------------------------------------
"""

  __multimethods = {} #Auto-generated by Spyder
  
  if "_ThreeDee__multimethods" in ThreeDee.__dict__: __multimethods.update(ThreeDee._ThreeDee__multimethods) #Auto-generated by Spyder
  
  if "_EThreeDee__multimethods" in EThreeDee.__dict__: __multimethods.update(EThreeDee._EThreeDee__multimethods) #Auto-generated by Spyder
  
  multimethod = functools.partial(spyder.core.__multimethod__,__multimethods) #Auto-generated by Spyder
    
  @staticmethod
  def typename():
    """Auto-generated by Spyder:
     module core
     file class.py
     function generate_class
    Return the class name of the current object"""
    return "RubikSnake"
  def cast(self, othertype):
    """Auto-generated by Spyder:
     module core
     file class.py
     function generate_class
    Return an object of the type "othertype" initialized from this object"""
    if type(othertype) == type(int): return othertype(self)    
    if hasattr(othertype, "wrapclass"): return othertype.wrapclass(self)
    return globals()[othertype](self)

  __constructor__ = "constructor_fromany" #Auto-generated by Spyder
  __defaultconstructor__ = __constructor__ #Auto-generated by Spyder
  def constructor_empty(self):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Empty constructor, all members must be assigned manually afterwards"""    
  def constructor_fromlist(self, *args, **args2):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    List constructor"""        
    a = self.__unpack__(*args[0])
    self.__construct__ (*a)
  def constructor_fromdict(self, dic):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Dict constructor"""       
    if isinstance(dic, dict) and "_ghostfile" in dic:   
      f = spyder.core.newnamespace()
      f.filename = dic["_ghostfile"][1:-1]
      self._ghostparam = [f, f]
      def getobj(obj):
        return obj                
      self.__dict__ = {"__print__":self._ghost__print__, "__str__":self.__str__, "__repr__": self.__repr__}      
      for k in dir(type(self)):
        if k == "__getattr__" or k in self.__dict__: continue
        self.__dict__[k] = functools.partial(self.__getattr__, k)   
      return                  
    a = self.__copydict__(dic)
    self.__construct__ (*a)              
 
  def __init__(self,*args, **args2):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Init function, calls the general constructor (fromany by default)"""            
    self.Annotation = {}
    for funcname in self.__multimethods:
      func, arg = self.__multimethods[funcname]
      self.__dict__[funcname] = functools.partial(func, **({arg:self}))    
    return RubikSnake.__dict__[RubikSnake.__constructor__](self, *args, **args2)
  def constructor_fromany(self,*args, **args2):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    General constructor for the current class
    This function tries five specialized constructors in this order:
    - Copy constructor
    - Dict constructor
    - Value/Keyword constructor
    - Parsing constructor
    - List constructor
    For more information, see the Spyder documentation"""

    raise_exc = None
    try:
      exc = "An error has occurred in the construction of a RubikSnake object"
      exc += "\nNumber of arguments: value %d, keyword %d\n" % (len(args), len(args2))
      try:
        construct = -1
        try:
          if len(args) > 1 or len(args2) > 0: raise IndexError
          a = self.__copy__(args[0]) #func(func(a,b,c))
        except AssertionError as e: 
          e.__context__ = None
          raise
        except Exception as e:
          if len(args) > 1 or len(args2) > 0: raise IndexError
          exc += "\n*** (RubikSnake) Copy constructor ***\n"+ spyder.exception()
          e.__context__ = None
          try:
            a = self.__copydict__(args[0]) #func({a:1,b:2,c:3})
          except Exception as e:          
            exc += "\n*** (RubikSnake) Dict constructor ***\n"+ spyder.exception()
            e.__context__ = None
            raise
          else:
            construct = 2
        else:
          construct = 1              
        self.__construct__ (*a)
      except AssertionError as e: 
        e.__context__ = None
        raise
      except Exception as e:
        e.__context__ = None
        if not (len(args) > 1 or len(args2) > 0):
          if construct == 1: exc += "\n*** Copy constructor (RubikSnake) ***\n" + spyder.exception()
          if construct == 2: exc += "\n*** Dict constructor (RubikSnake) ***\n" + spyder.exception()
        try:
          if len(args) == 1 and len(args2) == 0 and isinstance(args[0], str):
            if args[0].startswith("RubikSnake") and args[0][len("RubikSnake"):].lstrip()[0] == "(":
              raise TypeError
          a = self.__unpack__(*args, **args2) #func(a,b,c)
          self.__construct__ (*a) ##
        except AssertionError as e: 
          e.__context__ = None
          raise
        except Exception as e:
          exc += "\n*** (RubikSnake) Value/Keyword constructor ***\n" + spyder.exception()
          e.__context__ = None
          if len(args) > 1 or len(args2) > 0 : raise          
          try:
            a = self.__parse__(args[0]) #func("[a,b,c]")
            if a == None: return
            self.__construct__ (*a)
          except AssertionError as e: 
            e.__context__ = None
            raise
          except Exception as e:
            exc += "\n*** (RubikSnake) Parsing constructor ***\n" + spyder.exception()
            e.__context__ = None
            try:
              a = self.__unpack__(*args[0]) #func([a,b,c])
              self.__construct__ (*a)
            except Exception as e:
              exc += "\n*** (RubikSnake) List constructor ***\n" + spyder.exception()
              e.__context__ = None
              raise
      exc = "" 
      self.validate()
    except AssertionError: raise
    except Exception as err:
      if len(str(err).strip().strip('\n')) == 0: raise
      else: raise_exc = type(err)(exc+'\n'+str(err))
    if raise_exc: raise raise_exc  

  @classmethod
  def _typetree(cls): 
    """Auto-generated by Spyder:
     module core
     file typetree.py
     function typetree
    Returns the typetree of the Spyder class"""          
    spyder.core.build_members(cls.typename(),cls)
    return spyder.core.get_typetreedict(cls.typename())
  def __construct__ (self, size,turns,axis):
    """Auto-generated by Spyder:
     module core
     file construct.py
     function generate_construct
    General private constructor, for internal use only""" 
    if self.__constructor__ == self.__defaultconstructor__:
      def reconstruct(classtype, var):
        return classtype(var)
      reconstruct_default = reconstruct  
    else:
       def reconstruct_default(classtype, var):
         return classtype(var)    
       def reconstruct(classtype, var):         
         classtype.__constructor__ = self.__constructor__
         try:
           ret = classtype(var)
         finally:  
           classtype.__constructor__ = self.__defaultconstructor__
         return ret         
    try:
      self.size = reconstruct(Float,size)
    except AssertionError as exc: exc.__context__ = None; raise
    except Exception as err:
      err.__context__ = None; raise err.__class__("Member 'size':\n  " + str(err))
    reconstruct_func = reconstruct 
    default0 = self.__unpack__.__defaults__[0] if (sys.version_info[0] == 3) else self.__unpack__.func_defaults[0]
    if turns is default0 or (turns.__class__ is default0.__class__ and turns == default0):      reconstruct_func = reconstruct_default
    try:
      self.turns = reconstruct_func(IntegerArray,turns)
    except AssertionError as exc: exc.__context__ = None; raise
    except Exception as err:
      err.__context__ = None; raise err.__class__("Member 'turns':\n  " + str(err))
    reconstruct_func = reconstruct 
    default0 = self.__unpack__.__defaults__[1] if (sys.version_info[0] == 3) else self.__unpack__.func_defaults[1]
    if axis is default0 or (axis.__class__ is default0.__class__ and axis == default0):      reconstruct_func = reconstruct_default
    try:
      self.axis = reconstruct_func(AxisSystem,axis)
    except AssertionError as exc: exc.__context__ = None; raise
    except Exception as err:
      err.__context__ = None; raise err.__class__("Member 'axis':\n  " + str(err))
  def __unpack__(self,size,turns=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),axis=AxisSystem(),*_bogusargs, **_boguskwargs): 
    """Auto-generated by Spyder:
     module core
     file unpack.py
     function generate_unpack
    Private list/value/keyword constructor, for internal use only"""
    return size,turns,axis
  def __copy__(self,_a):
    """Auto-generated by Spyder:
     module core
     file copy.py
     function generate_copy
    Private copy constructor, for internal use only"""
    size = _a.size
    turns = (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
    if hasattr(_a,"turns") and _a.turns != None: turns = _a.turns
    axis = AxisSystem()
    if hasattr(_a,"axis") and _a.axis != None: axis = _a.axis
    if hasattr(_a, "__conversionstack__"): self.__conversionstack__ = _a.__conversionstack__
    self.Annotation = {}
    if hasattr(_a,"Annotation"): self.Annotation = _a.Annotation
    return (size,turns,axis,)
  def __copydict__(self,_a):
    """Auto-generated by Spyder:
     module core
     file copy.py
     function generate_copydict
    Private dict constructor, for internal use only"""
    size = _a["size"]
    turns = (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
    if "turns" in _a: turns = _a["turns"]
    if isinstance(_a, dict) and "turns" in _a: turns = _a["turns"]
    axis = AxisSystem()
    if "axis" in _a: axis = _a["axis"]
    if isinstance(_a, dict) and "axis" in _a: axis = _a["axis"]
    return (size,turns,axis,)
  def validate(self):
    """Auto-generated by Spyder:
     module core
     file validate.py
     function generate_validate
    Validates the current object
    This is automatically called after construction
    It is NOT automatically called after editing the object"""
    try:
      pass
      self.size = Float(self.size)
      self.turns = IntegerArray(self.turns)
      self.axis = AxisSystem(self.axis)
      self.__validate__()
    except Exception as inst: 
      if isinstance(inst, AssertionError):
        raise 
      else:
        #TODO; import sys
        #tb = sys.exc_info()[2]      
        #e = spyder.core.ValidationError
        #raise e, e(str(inst)), tb #TODO
        raise spyder.core.ValidationError(str(inst))
  def __validate__(self):
    """Auto-generated by Spyder:
     module core
     file validate.py
     function generate_intern_validate
    Private object validator, for internal use only"""
    size = self.size
    turns = self.turns
    axis = self.axis
    for t in turns:
      assert t in range(0,4)
    dir1,dir2,dir3 = 1,3,5
    posx,posy,posz = 0,0,0
    positions = {}
    positions[(posx,posy,posz)] = (dir1,dir2)
    for t in turns:
      posx,posy,posz = rubiksnakecode.move(posx,posy,posz,dir1)
      dir1,dir2,dir3 = rubiksnakecode.turn(dir1,dir2,dir3,t)
      if (posx,posy,posz) in positions:
        opposite = rubiksnakecode.get_opposite(positions[(posx,posy,posz)])
        if dir1 != opposite[0] or dir2 != opposite[1]: 
          raise ValidationError("Clash detected")
      positions[(posx,posy,posz)] = (dir1,dir2)
  def __len__(self):
    """Auto-generated by Spyder:
     module core
     file length.py
     function generate_len
    Return the length of the current object
    len(self) triggers this function, which redirects to self.length()"""
    return self.length()
  def __str__(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    This function is triggered by the print statement
    Redirects to self.__print__"""
    return self.__print__(0, "str")
  def str(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    Redirects to self.__print__"""
    return self.__print__(0, "str")
  def data(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    Redirects to self.__print__"""
    return self.__print__(0, "str")
  def repr(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_repr
    Converts the current object to a representation string
    As a side effect, saves all files within the object
    Redirects to self.__print__"""
    return self.__print__(0, "repr")
  def __repr__(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_repr
    Converts the current object to a representation string
    As a side effect, saves all files within the object
    Redirects to self.__print__"""
    return self.__print__(0, "repr")
  def __print__(self,spaces,mode):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_print
    Pretty-prints the current object, for internal use only
    Redirects to self.__print__"""
    ret = "%s (\n" % self.typename() 
    v = self.turns
    if type(v) != IntegerArray: v = IntegerArray(v)
    ret += "%sturns = " % ((spaces+2) * " ") + v.__print__(spaces+2, mode) + ",\n"
    v = self.size
    if type(v) != Float: v = Float(v)
    ret += "%ssize = " % ((spaces+2) * " ") + v.__print__(spaces+2, mode) + ",\n"
    v = self.axis
    if type(v) != AxisSystem: v = AxisSystem(v)
    ret += "%saxis = " % ((spaces+2) * " ") + v.__print__(spaces+2, mode) + ",\n"
    ret += "%s)" % (spaces * " ")
    return ret
  def dict(self):
    """Auto-generated by Spyder:
     module core
     file dict.py
     function generate_dict
    Converts the current object to a Python dictionary"""
    _d = {}
    v = self.turns
    if type(v) != IntegerArray: v = IntegerArray(v)
    _d["turns"] = v.dict()
    v = self.size
    if type(v) != Float: v = Float(v)
    _d["size"] = v.dict()
    v = self.axis
    if type(v) != AxisSystem: v = AxisSystem(v)
    _d["axis"] = v.dict()
    return _d
  def __parse__(self, s):
    """Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse
    Parsing constructor, which redirects to spyder.core.parse"""
    p = spyder.core.parse(s, "Spyder", True)
    if type(p) == type(self):
      self.__dict__ = p.__dict__
      return None       
    try:
      a = self.__unpack__(*p[0], **p[1])
    except:
      try:
        a = self.__copy__(p)
      except:
        a = self.__copydict__(p)
    return a
  @classmethod
  def fromfile(c, filename, fastparse=False):
    """Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse   
    fromfile constructor"""
    import os, traceback
    n = os.linesep
    if fastparse: 
      ret = spyder.core.fastparse(filename, c)
    else: 
      exc = "An error has occurred in the parsing of a " + c.typename() +  " object" 
      exc += n + "Filename: " + filename
      traces = n + "*** Tracebacks ***" + n
      try:
        try: #first attempt a parsing read, does not work with all data models
          data = spyder.core.parse(spyder.loader.file_load(filename).read())                
          ret = c.fromdict(data[1])
        except Exception as e: 
          head = n + "### Core parser ###" + n 
          exc += head + spyder.exception()
          traces += head
          traces += traceback.format_exc(e) + n
          e.__context__ = None      
          raise
      except Exception as e: 
        try: #read using File, also works with web links
          try:
            ret = spyder.__types__["File"](filename, c).data()
          except Exception as e:
            head = n + "### Spyder.File parser ###" + n 
            exc += head + spyder.exception()
            traces += head            
            traces += traceback.format_exc(e) + n
            e.__context__ = None
            raise                  
        except Exception as e:
          raise type(e)(exc + n + traces)
    return ret
  def tofile(self, filename):
    """Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse      
    Saves object to file"""
    f = spyder.__types__["File"](filename, type(self), "w", self)
    f.save()
    f.close()
  def totempfile(self):
    """Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse      
    Saves object to temporary file"""
    import random, os,tempfile
    tempdir = tempfile.gettempdir()
    while 1:
      tempnam = tempdir + os.sep + str(random.randrange(1,1000000000)) +".tmp"
      if not spyder.loader.file_exists(tempnam): break
    f = spyder.__types__["File"](tempnam, type(self), "w", self)
    f.temporary(True)
    f.save()
    return f
  def __getattr__(self, method):
    """Auto-generated by Spyder:
     module core
     file convert.py
     function generate_getattr
    Invokes the conversion engine """    
    m = spyder.core.method(RubikSnake, method, self)
    return m
  def convert(self, target,deepcopy=True):
    """Auto-generated by Spyder: 
     module core
     file convert.py
     function generate_convert
    Convert current object into type "target" """
    c = spyder.core.convert(RubikSnake, target, self, deepcopy)
    return c
  def threadconvert(self, target, deepcopy=True):
    """Auto-generated by Spyder:
     module core
     file convert.py
     function generate_convert
    Asynchronously convert current object into type "target"
    Immediately returns a waiting handle to the result
    Use spyder.core.thread.wait_all(<list of handles>)
     or spyder.core.thread.wait_any(<list of handles>)
     to wait for the result
    """
    c = spyder.core.spyderthread.threadstart (
     spyder.core.convert, (RubikSnake, target, self, deepcopy),
     name="RubikSnake=>%s" % target.typename(), 
    )
    return c
  
  def __ne__(self,_a): return not self.__eq__(_a)
  def __eq__(self,_a):
    """Auto-generated by Spyder:
     module core
     file eq.py
     function generate_eq
    Comparison operator"""
    try:
      if not isinstance(_a,RubikSnake) and not isinstance(self, type(_a)): return False
    except (TypeError, AttributeError, spyder.core.ValidationError): return False
    if _a is self: return True
    if self.size != _a.size: return False
    if self.turns != _a.turns: return False
    if self.axis != _a.axis: return False
    if not ThreeDee.__eq__(self, _a): return False
    if not EThreeDee.__eq__(self, _a): return False
    return True
  
  @classmethod
  def _form(cls):
    """Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Returns the spyderform of the class
     This function is automatically called at class creation"""
    return spyder.core.spyderforms[cls.typename()]
  @classmethod
  def __form__(cls):
    """Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Generates the spyderform of the class
     This function is automatically called at class creation"""
    self = spyder.core.spyderform(cls._typetree())
    size = self.size
    turns = self.turns
    axis = self.axis
    self.e3d = True
    self.matrix = "axis"
    size.default = 1
    size.range = 1
    turns[None].min = -1
    turns[None].max = 4
    turns[None].default = 0
  @staticmethod
  def blenderevent(self,blenderdata,currobj,currobjtype,currblenderdata,signalhead,signal,event=None,eventval=None,handles=None):
    if (signalhead, signal) == ("turns", "value-change"):
      v = currblenderdata["buttons"]["value"]
      if v.val == 4: v.val = 0
      if v.val == -1: v.val = 3      
    return self.blendereventpass(self,blenderdata,currobj,currobjtype,currblenderdata,signalhead,signal,event,eventval,handles)
spyder.__types__["RubikSnake"] = RubikSnake
RubikSnake._requiredmembers = [['Float', 'size', 2]]
RubikSnake._defaultmembers = [['IntegerArray', 'turns', '(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)', 1], ['AxisSystem', 'axis', 'AxisSystem()', 3]]
RubikSnake.__form__()

RubikSnake.empty = functools.partial(spyder.__constructor, 
  "constructor_empty",
  RubikSnake,
  "constructor_fromany",
)
RubikSnake.fromlist = functools.partial(spyder.__constructor, 
  "constructor_fromlist",
  RubikSnake,
  "constructor_fromany",
)
RubikSnake.fromdict = functools.partial(spyder.__constructor, 
  "constructor_fromdict",
  RubikSnake,
  "constructor_fromany",
)
for n in range(spyder.arraymax):
  classname = "RubikSnake" + (n+1) * "Array"
  prevclassname = "RubikSnake" + n * "Array"
  d = dict(typename="RubikSnake", classname=classname, prevclassname=prevclassname)
  defcode = 'class %s(spyder.core.spyderlist):\n' % classname
  defcode += '  @staticmethod\n  def typename(): return "%s"\n' % classname
  defcode += """  def cast(self, othertype):
    if type(othertype) == type: return othertype(self)
    return globals()[othertype](self)
"""
  defcode += """  def __arrayvalidate__(self):
    if self.__constructor__ == self.__defaultconstructor__:
      def reconstruct(classtype, var):
        return classtype(var)
    else:
       def reconstruct(classtype, var):         
         classtype.__constructor__ = self.__constructor__
         try:
           ret = classtype(var)
         finally:
           classtype.__constructor__ = self.__defaultconstructor__
         return ret               
    for v in range(len(self)):
      self[v] = reconstruct(%(prevclassname)s,self[v])
  def __validate__(self):
    try:
      self.__arrayvalidate__()
    except Exception as inst:
      if isinstance(inst, AssertionError):
        raise 
      else: raise spyder.core.ValidationError(str(inst))
\n""" % d
  defcode += """
  @classmethod
  def _typetree(cls): 
    \"\"\"Auto-generated by Spyder:
     module core
     file typetree.py
     function typetree
    Returns the typetree of the Spyder class\"\"\"          
    spyder.core.build_members(cls.typename(),cls)
    return spyder.core.get_typetreedict(cls.typename())
\n""" % d
  defcode += """  def __getattr__(self, method):    
      m = spyder.core.method(%(classname)s, method, self)
      return m
\n""" % d
  defcode += """  
  @classmethod
  def _form(cls):
    \"\"\"Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Returns the spyderform of the class
     This function is automatically called at class creation\"\"\"
    return spyder.core.spyderforms[cls.typename()]
  @classmethod
  def __form__(cls):
    \"\"\"Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Generates the spyderform of the class
     This function is automatically called at class creation\"\"\"
    spyder.core.spyderform(cls._typetree()) 
    t = cls.typename()
    while t.endswith("Array"): t = t[:-len("Array")]
    spyder.core.spyderforms[cls.typename()]._members = spyder.core.spyderforms[t]._members
\n""" % d
  defcode += """  def __str__(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    This function is triggered by the print statement
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "str")
  def str(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "str")
  def data(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "str")
\n""" % d
  defcode += """  def validate(self): self.__validate__()
\n""" % d
  defcode += """  def __print__(self,spaces,mode):
    ret = "%%s (\\n" %% self.typename()
    for v in self:
      ret += (spaces+2) * " " + v.__print__(spaces+2, mode) + ",\\n"
    ret += spaces * " " +  ")"
    return ret\n""" % d
  defcode += """  def __ne__(self,_a): return not self.__eq__(_a)
  def __eq__(self,_a):
    \"\"\"Auto-generated by Spyder:
     module core
     file eq.py
     function generate_eq
    Comparison operator\"\"\"
    if not isinstance(_a, %(classname)s) and not isinstance(self, type(_a)): return False
    if _a is self: return True
    if len(self) != len(_a): return False
    for n,nn in zip(self,_a):
      if n != nn: return False
    return True
\n""" % d
  defcode += """
  __constructor__ = "constructor_fromany"
  __defaultconstructor__ = __constructor__
  def constructor_empty(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Empty constructor, all members must be assigned manually afterwards\"\"\"
  def constructor_fromlist(self, *a):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    List constructor\"\"\"    
    list.__init__(self, *a)
    self.validate()
  def constructor_fromdict(self, *a):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Dict constructor\"\"\"    
    list.__init__(self, *a)
    self.validate()      
  
  def __init__(self,*a, **args2):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Init function, calls the general constructor (fromany by default)\"\"\"
    if len(args2.keys()): raise Exception          
    self.Annotation = {}
    return %(classname)s.__dict__[%(classname)s.__constructor__](self, *a)  
  def constructor_fromany(self, *a):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    General constructor for arrays\"\"\"    
    if len(a) == 0:
      spyder.core.spyderlist.__init__(self)
      return
    try:
      if len(a) == 1 and isinstance(a[0],str): raise Exception
      self.__copy__(*a)
    except AssertionError: raise
    except:
      try:
        if isinstance(a,str): raise Exception
        self.__copy__(a)      
      except AssertionError: raise
      except:
        if len(a) > 1: raise
        self.__parse__(a[0])
\n""" % d
  defcode += """  def __copy__(self,a):
    list.__init__(self, a)
    if hasattr(a, "__conversionstack__"): self.__conversionstack__ = a.__conversionstack__
    self.Annotation = {}
    if hasattr(a,"Annotation"): self.Annotation = a.Annotation
    self.__arrayvalidate__()      
 \n""" % d
  defcode += """  def convert(self, target,deepcopy=True):
    c = spyder.core.convert(%(classname)s, target, self, deepcopy)
    return c
  def threadconvert(self, target,deepcopy=True):
    c = spyder.core.spyderthread.threadstart (
     spyder.core.convert, (%(classname)s, target, self,deepcopy),
     name="%(classname)s=>%%s" %% target.typename(), 
    )
    return c    
\n""" % d
  defcode += """  
  def list(self):
    ret = []
    for vnr in range(len(self)):
      if type(self[vnr]) != RubikSnake: self[vnr] = RubikSnake(self[vnr])
      ret.append(self[vnr].dict())
    return ret  
  
  def dict(self):
    return self.list()
\n""" % d
  defcode += """  def __parse__(self, s):
    \"\"\"Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse   
    Parsing constructor, which redirects to spyder.core.parse\"\"\"
    args = spyder.core.parse(s, "Spyder", True)
    self.__copy__(args[0])
  @classmethod
  def fromfile(c, filename, fastparse=False):
    \"\"\"Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse   
    fromfile constructor\"\"\"
    import os, traceback
    n = os.linesep
    if fastparse: 
      ret = spyder.core.fastparse(filename, c)
    else: 
      exc = "An error has occurred in the parsing of a " + c.typename() +  " object" 
      exc += n + "Filename: " + filename
      traces = n + "*** Tracebacks ***" + n
      try:
        try: #first attempt a parsing read, does not work with all data models
          data = spyder.core.parse(spyder.loader.file_load(filename).read())                
          ret = c.fromdict(data[1])
        except Exception as e: 
          head = n + "### Core parser ###" + n 
          exc += head + spyder.exception()
          traces += head
          traces += traceback.format_exc(e) + n
          e.__context__ = None      
          raise
      except Exception as e: 
        try: #read using File, also works with web links
          try:
            ret = spyder.__types__["File"](filename, c).data()
          except Exception as e:
            head = n + "### Spyder.File parser ###" + n 
            exc += head + spyder.exception()
            traces += head            
            traces += traceback.format_exc(e) + n
            e.__context__ = None
            raise                  
        except Exception as e:
          raise type(e)(exc + n + traces)
    return ret
  def tofile(self, filename):
    \"\"\"Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse      
    Saves object to file\"\"\"
    f = spyder.__types__["File"](filename, type(self), "w", self)
    f.save()
    f.close()
  def totempfile(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse      
    Saves object to temporary file\"\"\"
    import random, os,tempfile
    tempdir = tempfile.gettempdir()
    while 1:
      tempnam = tempdir + os.sep + str(random.randrange(1,1000000000)) +".tmp"
      if not spyder.loader.file_exists(tempnam): break
    f = spyder.__types__["File"](tempnam, type(self), "w", self)
    f.temporary(True)
    f.save()
    return f
\n""" % d
  defcode += """  def repr(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_repr
    Converts the current object to a representation string
    As a side effect, saves all files within the object
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "repr")
  def __repr__(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_repr
    Converts the current object to a representation string
    As a side effect, saves all files within the object
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "repr")
\n""" % d
  defcode += "spyder.core.defineconverter(\"%(classname)s\",\"%(prevclassname)s\",\"SPLIT\")\n" % d
  defcode += "spyder.core.defineconverter(\"%(prevclassname)s\",\"%(classname)s\",\"CAST\")\n" % d
  exec(defcode)
  spyder.__types__[classname] = globals()[classname]

  arrayclass = spyder.__types__[classname]
  arrayclass.empty = functools.partial(spyder.__constructor, 
   "constructor_empty",
   arrayclass,
   "constructor_fromany",
  )
  arrayclass.fromlist = functools.partial(spyder.__constructor, 
   "constructor_fromlist",
   arrayclass,
   "constructor_fromany",
  )
  arrayclass.fromdict = functools.partial(spyder.__constructor, 
   "constructor_fromdict",
   arrayclass,
   "constructor_fromany",
  )
  arrayclass.__form__()


import functools
class RubikSnakeCode(ThreeDee,EThreeDee):
  """Spyder-generated class

 module spyder.modules.models3d
 file 'rubiksnake.spy'


   Representation of Rubik's Snake as code string
   during object construction, the string is not validated!
  
----------------------------------------------------------------------
Spyder definition:

Type RubikSnakeCode(ThreeDee,EThreeDee) {
  #!#!#!
  Representation of Rubik's Snake as code string
   during object construction, the string is not validated!
  #!#!#!
  String code
  Float size
  AxisSystem axis = AxisSystem()
  form {
    self.matrix = "axis"
    code.default = ""
    code.length = 100
    size.default = 1
    size.range = 1
  }    
}

----------------------------------------------------------------------
"""

  __multimethods = {} #Auto-generated by Spyder
  
  if "_ThreeDee__multimethods" in ThreeDee.__dict__: __multimethods.update(ThreeDee._ThreeDee__multimethods) #Auto-generated by Spyder
  
  if "_EThreeDee__multimethods" in EThreeDee.__dict__: __multimethods.update(EThreeDee._EThreeDee__multimethods) #Auto-generated by Spyder
  
  multimethod = functools.partial(spyder.core.__multimethod__,__multimethods) #Auto-generated by Spyder
    
  @staticmethod
  def typename():
    """Auto-generated by Spyder:
     module core
     file class.py
     function generate_class
    Return the class name of the current object"""
    return "RubikSnakeCode"
  def cast(self, othertype):
    """Auto-generated by Spyder:
     module core
     file class.py
     function generate_class
    Return an object of the type "othertype" initialized from this object"""
    if type(othertype) == type(int): return othertype(self)    
    if hasattr(othertype, "wrapclass"): return othertype.wrapclass(self)
    return globals()[othertype](self)

  __constructor__ = "constructor_fromany" #Auto-generated by Spyder
  __defaultconstructor__ = __constructor__ #Auto-generated by Spyder
  def constructor_empty(self):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Empty constructor, all members must be assigned manually afterwards"""    
  def constructor_fromlist(self, *args, **args2):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    List constructor"""        
    a = self.__unpack__(*args[0])
    self.__construct__ (*a)
  def constructor_fromdict(self, dic):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Dict constructor"""       
    if isinstance(dic, dict) and "_ghostfile" in dic:   
      f = spyder.core.newnamespace()
      f.filename = dic["_ghostfile"][1:-1]
      self._ghostparam = [f, f]
      def getobj(obj):
        return obj                
      self.__dict__ = {"__print__":self._ghost__print__, "__str__":self.__str__, "__repr__": self.__repr__}      
      for k in dir(type(self)):
        if k == "__getattr__" or k in self.__dict__: continue
        self.__dict__[k] = functools.partial(self.__getattr__, k)   
      return                  
    a = self.__copydict__(dic)
    self.__construct__ (*a)              
 
  def __init__(self,*args, **args2):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Init function, calls the general constructor (fromany by default)"""            
    self.Annotation = {}
    for funcname in self.__multimethods:
      func, arg = self.__multimethods[funcname]
      self.__dict__[funcname] = functools.partial(func, **({arg:self}))    
    return RubikSnakeCode.__dict__[RubikSnakeCode.__constructor__](self, *args, **args2)
  def constructor_fromany(self,*args, **args2):
    """Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    General constructor for the current class
    This function tries five specialized constructors in this order:
    - Copy constructor
    - Dict constructor
    - Value/Keyword constructor
    - Parsing constructor
    - List constructor
    For more information, see the Spyder documentation"""

    raise_exc = None
    try:
      exc = "An error has occurred in the construction of a RubikSnakeCode object"
      exc += "\nNumber of arguments: value %d, keyword %d\n" % (len(args), len(args2))
      try:
        construct = -1
        try:
          if len(args) > 1 or len(args2) > 0: raise IndexError
          a = self.__copy__(args[0]) #func(func(a,b,c))
        except AssertionError as e: 
          e.__context__ = None
          raise
        except Exception as e:
          if len(args) > 1 or len(args2) > 0: raise IndexError
          exc += "\n*** (RubikSnakeCode) Copy constructor ***\n"+ spyder.exception()
          e.__context__ = None
          try:
            a = self.__copydict__(args[0]) #func({a:1,b:2,c:3})
          except Exception as e:          
            exc += "\n*** (RubikSnakeCode) Dict constructor ***\n"+ spyder.exception()
            e.__context__ = None
            raise
          else:
            construct = 2
        else:
          construct = 1              
        self.__construct__ (*a)
      except AssertionError as e: 
        e.__context__ = None
        raise
      except Exception as e:
        e.__context__ = None
        if not (len(args) > 1 or len(args2) > 0):
          if construct == 1: exc += "\n*** Copy constructor (RubikSnakeCode) ***\n" + spyder.exception()
          if construct == 2: exc += "\n*** Dict constructor (RubikSnakeCode) ***\n" + spyder.exception()
        try:
          if len(args) == 1 and len(args2) == 0 and isinstance(args[0], str):
            if args[0].startswith("RubikSnakeCode") and args[0][len("RubikSnakeCode"):].lstrip()[0] == "(":
              raise TypeError
          a = self.__unpack__(*args, **args2) #func(a,b,c)
          self.__construct__ (*a) ##
        except AssertionError as e: 
          e.__context__ = None
          raise
        except Exception as e:
          exc += "\n*** (RubikSnakeCode) Value/Keyword constructor ***\n" + spyder.exception()
          e.__context__ = None
          if len(args) > 1 or len(args2) > 0 : raise          
          try:
            a = self.__parse__(args[0]) #func("[a,b,c]")
            if a == None: return
            self.__construct__ (*a)
          except AssertionError as e: 
            e.__context__ = None
            raise
          except Exception as e:
            exc += "\n*** (RubikSnakeCode) Parsing constructor ***\n" + spyder.exception()
            e.__context__ = None
            try:
              a = self.__unpack__(*args[0]) #func([a,b,c])
              self.__construct__ (*a)
            except Exception as e:
              exc += "\n*** (RubikSnakeCode) List constructor ***\n" + spyder.exception()
              e.__context__ = None
              raise
      exc = "" 
      self.validate()
    except AssertionError: raise
    except Exception as err:
      if len(str(err).strip().strip('\n')) == 0: raise
      else: raise_exc = type(err)(exc+'\n'+str(err))
    if raise_exc: raise raise_exc  

  @classmethod
  def _typetree(cls): 
    """Auto-generated by Spyder:
     module core
     file typetree.py
     function typetree
    Returns the typetree of the Spyder class"""          
    spyder.core.build_members(cls.typename(),cls)
    return spyder.core.get_typetreedict(cls.typename())
  def __construct__ (self, code,size,axis):
    """Auto-generated by Spyder:
     module core
     file construct.py
     function generate_construct
    General private constructor, for internal use only""" 
    if self.__constructor__ == self.__defaultconstructor__:
      def reconstruct(classtype, var):
        return classtype(var)
      reconstruct_default = reconstruct  
    else:
       def reconstruct_default(classtype, var):
         return classtype(var)    
       def reconstruct(classtype, var):         
         classtype.__constructor__ = self.__constructor__
         try:
           ret = classtype(var)
         finally:  
           classtype.__constructor__ = self.__defaultconstructor__
         return ret         
    try:
      self.code = reconstruct(String,code)
    except AssertionError as exc: exc.__context__ = None; raise
    except Exception as err:
      err.__context__ = None; raise err.__class__("Member 'code':\n  " + str(err))
    try:
      self.size = reconstruct(Float,size)
    except AssertionError as exc: exc.__context__ = None; raise
    except Exception as err:
      err.__context__ = None; raise err.__class__("Member 'size':\n  " + str(err))
    reconstruct_func = reconstruct 
    default0 = self.__unpack__.__defaults__[0] if (sys.version_info[0] == 3) else self.__unpack__.func_defaults[0]
    if axis is default0 or (axis.__class__ is default0.__class__ and axis == default0):      reconstruct_func = reconstruct_default
    try:
      self.axis = reconstruct_func(AxisSystem,axis)
    except AssertionError as exc: exc.__context__ = None; raise
    except Exception as err:
      err.__context__ = None; raise err.__class__("Member 'axis':\n  " + str(err))
  def __unpack__(self,code,size,axis=AxisSystem(),*_bogusargs, **_boguskwargs): 
    """Auto-generated by Spyder:
     module core
     file unpack.py
     function generate_unpack
    Private list/value/keyword constructor, for internal use only"""
    return code,size,axis
  def __copy__(self,_a):
    """Auto-generated by Spyder:
     module core
     file copy.py
     function generate_copy
    Private copy constructor, for internal use only"""
    code = _a.code
    size = _a.size
    axis = AxisSystem()
    if hasattr(_a,"axis") and _a.axis != None: axis = _a.axis
    if hasattr(_a, "__conversionstack__"): self.__conversionstack__ = _a.__conversionstack__
    self.Annotation = {}
    if hasattr(_a,"Annotation"): self.Annotation = _a.Annotation
    return (code,size,axis,)
  def __copydict__(self,_a):
    """Auto-generated by Spyder:
     module core
     file copy.py
     function generate_copydict
    Private dict constructor, for internal use only"""
    code = _a["code"]
    size = _a["size"]
    axis = AxisSystem()
    if "axis" in _a: axis = _a["axis"]
    if isinstance(_a, dict) and "axis" in _a: axis = _a["axis"]
    return (code,size,axis,)
  def validate(self):
    """Auto-generated by Spyder:
     module core
     file validate.py
     function generate_validate
    Validates the current object
    This is automatically called after construction
    It is NOT automatically called after editing the object"""
    try:
      pass
      self.code = String(self.code)
      self.size = Float(self.size)
      self.axis = AxisSystem(self.axis)
      self.__validate__()
    except Exception as inst: 
      if isinstance(inst, AssertionError):
        raise 
      else:
        #TODO; import sys
        #tb = sys.exc_info()[2]      
        #e = spyder.core.ValidationError
        #raise e, e(str(inst)), tb #TODO
        raise spyder.core.ValidationError(str(inst))
  def __validate__(self):
    """Auto-generated by Spyder:
     module core
     file validate.py
     function generate_intern_validate
    Private object validator, for internal use only"""
    pass
  def __len__(self):
    """Auto-generated by Spyder:
     module core
     file length.py
     function generate_len
    Return the length of the current object
    len(self) triggers this function, which redirects to self.length()"""
    return self.length()
  def __str__(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    This function is triggered by the print statement
    Redirects to self.__print__"""
    return self.__print__(0, "str")
  def str(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    Redirects to self.__print__"""
    return self.__print__(0, "str")
  def data(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    Redirects to self.__print__"""
    return self.__print__(0, "str")
  def repr(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_repr
    Converts the current object to a representation string
    As a side effect, saves all files within the object
    Redirects to self.__print__"""
    return self.__print__(0, "repr")
  def __repr__(self):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_repr
    Converts the current object to a representation string
    As a side effect, saves all files within the object
    Redirects to self.__print__"""
    return self.__print__(0, "repr")
  def __print__(self,spaces,mode):
    """Auto-generated by Spyder:
     module core
     file print.py
     function generate_print
    Pretty-prints the current object, for internal use only
    Redirects to self.__print__"""
    ret = "%s (\n" % self.typename() 
    v = self.code
    if type(v) != String: v = String(v)
    ret += "%scode = " % ((spaces+2) * " ") + v.__print__(spaces+2, mode) + ",\n"
    v = self.size
    if type(v) != Float: v = Float(v)
    ret += "%ssize = " % ((spaces+2) * " ") + v.__print__(spaces+2, mode) + ",\n"
    v = self.axis
    if type(v) != AxisSystem: v = AxisSystem(v)
    ret += "%saxis = " % ((spaces+2) * " ") + v.__print__(spaces+2, mode) + ",\n"
    ret += "%s)" % (spaces * " ")
    return ret
  def dict(self):
    """Auto-generated by Spyder:
     module core
     file dict.py
     function generate_dict
    Converts the current object to a Python dictionary"""
    _d = {}
    v = self.code
    if type(v) != String: v = String(v)
    _d["code"] = v.dict()
    v = self.size
    if type(v) != Float: v = Float(v)
    _d["size"] = v.dict()
    v = self.axis
    if type(v) != AxisSystem: v = AxisSystem(v)
    _d["axis"] = v.dict()
    return _d
  def __parse__(self, s):
    """Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse
    Parsing constructor, which redirects to spyder.core.parse"""
    p = spyder.core.parse(s, "Spyder", True)
    if type(p) == type(self):
      self.__dict__ = p.__dict__
      return None       
    try:
      a = self.__unpack__(*p[0], **p[1])
    except:
      try:
        a = self.__copy__(p)
      except:
        a = self.__copydict__(p)
    return a
  @classmethod
  def fromfile(c, filename, fastparse=False):
    """Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse   
    fromfile constructor"""
    import os, traceback
    n = os.linesep
    if fastparse: 
      ret = spyder.core.fastparse(filename, c)
    else: 
      exc = "An error has occurred in the parsing of a " + c.typename() +  " object" 
      exc += n + "Filename: " + filename
      traces = n + "*** Tracebacks ***" + n
      try:
        try: #first attempt a parsing read, does not work with all data models
          data = spyder.core.parse(spyder.loader.file_load(filename).read())                
          ret = c.fromdict(data[1])
        except Exception as e: 
          head = n + "### Core parser ###" + n 
          exc += head + spyder.exception()
          traces += head
          traces += traceback.format_exc(e) + n
          e.__context__ = None      
          raise
      except Exception as e: 
        try: #read using File, also works with web links
          try:
            ret = spyder.__types__["File"](filename, c).data()
          except Exception as e:
            head = n + "### Spyder.File parser ###" + n 
            exc += head + spyder.exception()
            traces += head            
            traces += traceback.format_exc(e) + n
            e.__context__ = None
            raise                  
        except Exception as e:
          raise type(e)(exc + n + traces)
    return ret
  def tofile(self, filename):
    """Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse      
    Saves object to file"""
    f = spyder.__types__["File"](filename, type(self), "w", self)
    f.save()
    f.close()
  def totempfile(self):
    """Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse      
    Saves object to temporary file"""
    import random, os,tempfile
    tempdir = tempfile.gettempdir()
    while 1:
      tempnam = tempdir + os.sep + str(random.randrange(1,1000000000)) +".tmp"
      if not spyder.loader.file_exists(tempnam): break
    f = spyder.__types__["File"](tempnam, type(self), "w", self)
    f.temporary(True)
    f.save()
    return f
  def __getattr__(self, method):
    """Auto-generated by Spyder:
     module core
     file convert.py
     function generate_getattr
    Invokes the conversion engine """    
    m = spyder.core.method(RubikSnakeCode, method, self)
    return m
  def convert(self, target,deepcopy=True):
    """Auto-generated by Spyder: 
     module core
     file convert.py
     function generate_convert
    Convert current object into type "target" """
    c = spyder.core.convert(RubikSnakeCode, target, self, deepcopy)
    return c
  def threadconvert(self, target, deepcopy=True):
    """Auto-generated by Spyder:
     module core
     file convert.py
     function generate_convert
    Asynchronously convert current object into type "target"
    Immediately returns a waiting handle to the result
    Use spyder.core.thread.wait_all(<list of handles>)
     or spyder.core.thread.wait_any(<list of handles>)
     to wait for the result
    """
    c = spyder.core.spyderthread.threadstart (
     spyder.core.convert, (RubikSnakeCode, target, self, deepcopy),
     name="RubikSnakeCode=>%s" % target.typename(), 
    )
    return c
  
  def __ne__(self,_a): return not self.__eq__(_a)
  def __eq__(self,_a):
    """Auto-generated by Spyder:
     module core
     file eq.py
     function generate_eq
    Comparison operator"""
    try:
      if not isinstance(_a,RubikSnakeCode) and not isinstance(self, type(_a)): return False
    except (TypeError, AttributeError, spyder.core.ValidationError): return False
    if _a is self: return True
    if self.code != _a.code: return False
    if self.size != _a.size: return False
    if self.axis != _a.axis: return False
    if not ThreeDee.__eq__(self, _a): return False
    if not EThreeDee.__eq__(self, _a): return False
    return True
  
  @classmethod
  def _form(cls):
    """Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Returns the spyderform of the class
     This function is automatically called at class creation"""
    return spyder.core.spyderforms[cls.typename()]
  @classmethod
  def __form__(cls):
    """Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Generates the spyderform of the class
     This function is automatically called at class creation"""
    self = spyder.core.spyderform(cls._typetree())
    code = self.code
    size = self.size
    axis = self.axis
    self.e3d = True
    self.matrix = "axis"
    code.default = ""
    code.length = 100
    size.default = 1
    size.range = 1
spyder.__types__["RubikSnakeCode"] = RubikSnakeCode
RubikSnakeCode._requiredmembers = [['String', 'code', 1], ['Float', 'size', 2]]
RubikSnakeCode._defaultmembers = [['AxisSystem', 'axis', 'AxisSystem()', 3]]
RubikSnakeCode.__form__()

RubikSnakeCode.empty = functools.partial(spyder.__constructor, 
  "constructor_empty",
  RubikSnakeCode,
  "constructor_fromany",
)
RubikSnakeCode.fromlist = functools.partial(spyder.__constructor, 
  "constructor_fromlist",
  RubikSnakeCode,
  "constructor_fromany",
)
RubikSnakeCode.fromdict = functools.partial(spyder.__constructor, 
  "constructor_fromdict",
  RubikSnakeCode,
  "constructor_fromany",
)
for n in range(spyder.arraymax):
  classname = "RubikSnakeCode" + (n+1) * "Array"
  prevclassname = "RubikSnakeCode" + n * "Array"
  d = dict(typename="RubikSnakeCode", classname=classname, prevclassname=prevclassname)
  defcode = 'class %s(spyder.core.spyderlist):\n' % classname
  defcode += '  @staticmethod\n  def typename(): return "%s"\n' % classname
  defcode += """  def cast(self, othertype):
    if type(othertype) == type: return othertype(self)
    return globals()[othertype](self)
"""
  defcode += """  def __arrayvalidate__(self):
    if self.__constructor__ == self.__defaultconstructor__:
      def reconstruct(classtype, var):
        return classtype(var)
    else:
       def reconstruct(classtype, var):         
         classtype.__constructor__ = self.__constructor__
         try:
           ret = classtype(var)
         finally:
           classtype.__constructor__ = self.__defaultconstructor__
         return ret               
    for v in range(len(self)):
      self[v] = reconstruct(%(prevclassname)s,self[v])
  def __validate__(self):
    try:
      self.__arrayvalidate__()
    except Exception as inst:
      if isinstance(inst, AssertionError):
        raise 
      else: raise spyder.core.ValidationError(str(inst))
\n""" % d
  defcode += """
  @classmethod
  def _typetree(cls): 
    \"\"\"Auto-generated by Spyder:
     module core
     file typetree.py
     function typetree
    Returns the typetree of the Spyder class\"\"\"          
    spyder.core.build_members(cls.typename(),cls)
    return spyder.core.get_typetreedict(cls.typename())
\n""" % d
  defcode += """  def __getattr__(self, method):    
      m = spyder.core.method(%(classname)s, method, self)
      return m
\n""" % d
  defcode += """  
  @classmethod
  def _form(cls):
    \"\"\"Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Returns the spyderform of the class
     This function is automatically called at class creation\"\"\"
    return spyder.core.spyderforms[cls.typename()]
  @classmethod
  def __form__(cls):
    \"\"\"Auto-generated by Spyder:
     module core
     file form.py
     function generate_form
     Generates the spyderform of the class
     This function is automatically called at class creation\"\"\"
    spyder.core.spyderform(cls._typetree()) 
    t = cls.typename()
    while t.endswith("Array"): t = t[:-len("Array")]
    spyder.core.spyderforms[cls.typename()]._members = spyder.core.spyderforms[t]._members
\n""" % d
  defcode += """  def __str__(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    This function is triggered by the print statement
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "str")
  def str(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "str")
  def data(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_str
    Converts the current object to a string
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "str")
\n""" % d
  defcode += """  def validate(self): self.__validate__()
\n""" % d
  defcode += """  def __print__(self,spaces,mode):
    ret = "%%s (\\n" %% self.typename()
    for v in self:
      ret += (spaces+2) * " " + v.__print__(spaces+2, mode) + ",\\n"
    ret += spaces * " " +  ")"
    return ret\n""" % d
  defcode += """  def __ne__(self,_a): return not self.__eq__(_a)
  def __eq__(self,_a):
    \"\"\"Auto-generated by Spyder:
     module core
     file eq.py
     function generate_eq
    Comparison operator\"\"\"
    if not isinstance(_a, %(classname)s) and not isinstance(self, type(_a)): return False
    if _a is self: return True
    if len(self) != len(_a): return False
    for n,nn in zip(self,_a):
      if n != nn: return False
    return True
\n""" % d
  defcode += """
  __constructor__ = "constructor_fromany"
  __defaultconstructor__ = __constructor__
  def constructor_empty(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Empty constructor, all members must be assigned manually afterwards\"\"\"
  def constructor_fromlist(self, *a):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    List constructor\"\"\"    
    list.__init__(self, *a)
    self.validate()
  def constructor_fromdict(self, *a):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Dict constructor\"\"\"    
    list.__init__(self, *a)
    self.validate()      
  
  def __init__(self,*a, **args2):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    Init function, calls the general constructor (fromany by default)\"\"\"
    if len(args2.keys()): raise Exception          
    self.Annotation = {}
    return %(classname)s.__dict__[%(classname)s.__constructor__](self, *a)  
  def constructor_fromany(self, *a):
    \"\"\"Auto-generated by Spyder:
     module core
     file init.py
     function generate_init
    General constructor for arrays\"\"\"    
    if len(a) == 0:
      spyder.core.spyderlist.__init__(self)
      return
    try:
      if len(a) == 1 and isinstance(a[0],str): raise Exception
      self.__copy__(*a)
    except AssertionError: raise
    except:
      try:
        if isinstance(a,str): raise Exception
        self.__copy__(a)      
      except AssertionError: raise
      except:
        if len(a) > 1: raise
        self.__parse__(a[0])
\n""" % d
  defcode += """  def __copy__(self,a):
    list.__init__(self, a)
    if hasattr(a, "__conversionstack__"): self.__conversionstack__ = a.__conversionstack__
    self.Annotation = {}
    if hasattr(a,"Annotation"): self.Annotation = a.Annotation
    self.__arrayvalidate__()      
 \n""" % d
  defcode += """  def convert(self, target,deepcopy=True):
    c = spyder.core.convert(%(classname)s, target, self, deepcopy)
    return c
  def threadconvert(self, target,deepcopy=True):
    c = spyder.core.spyderthread.threadstart (
     spyder.core.convert, (%(classname)s, target, self,deepcopy),
     name="%(classname)s=>%%s" %% target.typename(), 
    )
    return c    
\n""" % d
  defcode += """  
  def list(self):
    ret = []
    for vnr in range(len(self)):
      if type(self[vnr]) != RubikSnakeCode: self[vnr] = RubikSnakeCode(self[vnr])
      ret.append(self[vnr].dict())
    return ret  
  
  def dict(self):
    return self.list()
\n""" % d
  defcode += """  def __parse__(self, s):
    \"\"\"Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse   
    Parsing constructor, which redirects to spyder.core.parse\"\"\"
    args = spyder.core.parse(s, "Spyder", True)
    self.__copy__(args[0])
  @classmethod
  def fromfile(c, filename, fastparse=False):
    \"\"\"Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse   
    fromfile constructor\"\"\"
    import os, traceback
    n = os.linesep
    if fastparse: 
      ret = spyder.core.fastparse(filename, c)
    else: 
      exc = "An error has occurred in the parsing of a " + c.typename() +  " object" 
      exc += n + "Filename: " + filename
      traces = n + "*** Tracebacks ***" + n
      try:
        try: #first attempt a parsing read, does not work with all data models
          data = spyder.core.parse(spyder.loader.file_load(filename).read())                
          ret = c.fromdict(data[1])
        except Exception as e: 
          head = n + "### Core parser ###" + n 
          exc += head + spyder.exception()
          traces += head
          traces += traceback.format_exc(e) + n
          e.__context__ = None      
          raise
      except Exception as e: 
        try: #read using File, also works with web links
          try:
            ret = spyder.__types__["File"](filename, c).data()
          except Exception as e:
            head = n + "### Spyder.File parser ###" + n 
            exc += head + spyder.exception()
            traces += head            
            traces += traceback.format_exc(e) + n
            e.__context__ = None
            raise                  
        except Exception as e:
          raise type(e)(exc + n + traces)
    return ret
  def tofile(self, filename):
    \"\"\"Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse      
    Saves object to file\"\"\"
    f = spyder.__types__["File"](filename, type(self), "w", self)
    f.save()
    f.close()
  def totempfile(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file parse.py
     function generate_parse      
    Saves object to temporary file\"\"\"
    import random, os,tempfile
    tempdir = tempfile.gettempdir()
    while 1:
      tempnam = tempdir + os.sep + str(random.randrange(1,1000000000)) +".tmp"
      if not spyder.loader.file_exists(tempnam): break
    f = spyder.__types__["File"](tempnam, type(self), "w", self)
    f.temporary(True)
    f.save()
    return f
\n""" % d
  defcode += """  def repr(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_repr
    Converts the current object to a representation string
    As a side effect, saves all files within the object
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "repr")
  def __repr__(self):
    \"\"\"Auto-generated by Spyder:
     module core
     file print.py
     function generate_repr
    Converts the current object to a representation string
    As a side effect, saves all files within the object
    Redirects to self.__print__\"\"\"
    return self.__print__(0, "repr")
\n""" % d
  defcode += "spyder.core.defineconverter(\"%(classname)s\",\"%(prevclassname)s\",\"SPLIT\")\n" % d
  defcode += "spyder.core.defineconverter(\"%(prevclassname)s\",\"%(classname)s\",\"CAST\")\n" % d
  exec(defcode)
  spyder.__types__[classname] = globals()[classname]

  arrayclass = spyder.__types__[classname]
  arrayclass.empty = functools.partial(spyder.__constructor, 
   "constructor_empty",
   arrayclass,
   "constructor_fromany",
  )
  arrayclass.fromlist = functools.partial(spyder.__constructor, 
   "constructor_fromlist",
   arrayclass,
   "constructor_fromany",
  )
  arrayclass.fromdict = functools.partial(spyder.__constructor, 
   "constructor_fromdict",
   arrayclass,
   "constructor_fromany",
  )
  arrayclass.__form__()

"""Define RubikSnake(RubikSnakeCode c) {
  turns = [0,] * 23

  k = [kk for kk in c.code.strip().split("-") if len(kk) > 0]
  for t in k:
    nr = 2*int(t[:-2])-2
    if t[-2] == 'R':       
       turns[nr]=int(t[-1])
    else:
       turns[nr-1]=4-int(t[-1])

  r = RubikSnake (
    turns = turns,
    size = c.size,
    axis = c.axis
  )
  return r
}"""
def spyderconverterfunction_11(c):
  turns = [0,] * 23
  k = [kk for kk in c.code.strip().split("-") if len(kk) > 0]
  for t in k:
    nr = 2*int(t[:-2])-2
    if t[-2] == 'R':       
       turns[nr]=int(t[-1])
    else:
       turns[nr-1]=4-int(t[-1])
  r = RubikSnake (
    turns = turns,
    size = c.size,
    axis = c.axis
  )
  return r

spyder.core.defineconverter("RubikSnakeCode","RubikSnake",spyderconverterfunction_11)

del spyderconverterfunction_11
"""Define RubikSnakeCode(RubikSnake r) {
  l = len(r.turns)
  if l < 23: return None
  if l > 23: l = 23
  turns = [0,] * 23
  
  code = ""
  for nr in range(l):
    lr, ori = "R", r.turns[nr]
    t = (nr+2)/2
    if ori == 0: continue
    if nr % 2: 
      lr,ori = "L", 4 - ori
      t += 1
    t = str(t)+ lr + str(ori)
    code += t + "-"
  code = code[:-1]
    
  c = RubikSnakeCode (
    code = code,
    size = r.size,
    axis = r.axis
  )
  return c
}"""
def spyderconverterfunction_12(r):
  l = len(r.turns)
  if l < 23: return None
  if l > 23: l = 23
  turns = [0,] * 23
  code = ""
  for nr in range(l):
    lr, ori = "R", r.turns[nr]
    t = (nr+2)/2
    if ori == 0: continue
    if nr % 2: 
      lr,ori = "L", 4 - ori
      t += 1
    t = str(t)+ lr + str(ori)
    code += t + "-"
  code = code[:-1]
  c = RubikSnakeCode (
    code = code,
    size = r.size,
    axis = r.axis
  )
  return c

spyder.core.defineconverter("RubikSnake","RubikSnakeCode",spyderconverterfunction_12)

del spyderconverterfunction_12
"""Define Object3D(RubikSnake r) {
  dir1,dir2,dir3 = 1,3,6
  posx,posy,posz = 0,0,0
  p1 = Coordinate(0,0,0)
  p2 = Coordinate(rubiksnakecode.move(p1.x,p1.y,p1.z,dir3))
  p3 = Coordinate(rubiksnakecode.move(p1.x,p1.y,p1.z,dir1))
  p4 = Coordinate(rubiksnakecode.move(p3.x,p3.y,p3.z,dir3))
  i1,i2,i3,i4 = 0,1,2,3
  vertices = [p1,p2,p3,p4]
  if Spyder.tarantula.get_material("rubiksnake_white") == None:
     NewMaterial("rubiksnake_white", color=(255,255,255)).show()
  if Spyder.tarantula.get_material("rubiksnake_black") == None:
     NewMaterial("rubiksnake_black", color=(76,38,0)).show()
  materials = ("rubiksnake_black", "rubiksnake_white")
  currmaterial = 0
  faces = [Face3D(material=materials[currmaterial],vertices=(i1,i2,i4,i3)),]
  for t in r.turns:
    p5 = Coordinate(rubiksnakecode.move(p3.x,p3.y,p3.z,dir2))
    p6 = Coordinate(rubiksnakecode.move(p4.x,p4.y,p4.z,dir2))
    i5, i6 = len(vertices), len(vertices) + 1
    vertices += (p5,p6)
    faces.append(Face3D(material=materials[currmaterial],vertices=(i1,i5,i6,i2)))
    faces.append(Face3D(material=materials[currmaterial],vertices=(i1,i3,i5)))
    faces.append(Face3D(material=materials[currmaterial],vertices=(i2,i6,i4)))
    p1,p2,p3,p4 = p4,p3,p6,p5
    i1,i2,i3,i4 = i4,i3,i6,i5
    for tt in range(t): 
      p1,p2,p4,p3 = p2,p4,p3,p1
      i1,i2,i4,i3 = i2,i4,i3,i1
    posx,posy,posz = rubiksnakecode.move(posx,posy,posz,dir1)
    dir1,dir2,dir3 = rubiksnakecode.turn(dir1,dir2,dir3,t)

    currmaterial = 1 - currmaterial
  p5 = Coordinate(rubiksnakecode.move(p3.x,p3.y,p3.z,dir2))
  p6 = Coordinate(rubiksnakecodeg.move(p4.x,p4.y,p4.z,dir2))
  i5, i6 = len(vertices), len(vertices) + 1
  vertices += (p5,p6)
  faces.append(Face3D(material=materials[currmaterial],vertices=(i1,i5,i6,i2)))
  faces.append(Face3D(material=materials[currmaterial],vertices=(i1,i3,i5)))
  faces.append(Face3D(material=materials[currmaterial],vertices=(i2,i6,i4)))
  faces.append(Face3D(material=materials[currmaterial],vertices=(i3,i4,i6,i5)))
  for v in vertices: 
    v.x *= r.size
    v.y *= r.size
    v.z *= r.size

  o = Object3D(vertices=vertices,faces=faces,material="rubiksnake_white",axis=r.axis)
  return o
}"""
def spyderconverterfunction_13(r):
  dir1,dir2,dir3 = 1,3,6
  posx,posy,posz = 0,0,0
  p1 = Coordinate(0,0,0)
  p2 = Coordinate(rubiksnakecode.move(p1.x,p1.y,p1.z,dir3))
  p3 = Coordinate(rubiksnakecode.move(p1.x,p1.y,p1.z,dir1))
  p4 = Coordinate(rubiksnakecode.move(p3.x,p3.y,p3.z,dir3))
  i1,i2,i3,i4 = 0,1,2,3
  vertices = [p1,p2,p3,p4]
  if Spyder.tarantula.get_material("rubiksnake_white") == None:
     NewMaterial("rubiksnake_white", color=(255,255,255)).show()
  if Spyder.tarantula.get_material("rubiksnake_black") == None:
     NewMaterial("rubiksnake_black", color=(76,38,0)).show()
  materials = ("rubiksnake_black", "rubiksnake_white")
  currmaterial = 0
  faces = [Face3D(material=materials[currmaterial],vertices=(i1,i2,i4,i3)),]
  for t in r.turns:
    p5 = Coordinate(rubiksnakecode.move(p3.x,p3.y,p3.z,dir2))
    p6 = Coordinate(rubiksnakecode.move(p4.x,p4.y,p4.z,dir2))
    i5, i6 = len(vertices), len(vertices) + 1
    vertices += (p5,p6)
    faces.append(Face3D(material=materials[currmaterial],vertices=(i1,i5,i6,i2)))
    faces.append(Face3D(material=materials[currmaterial],vertices=(i1,i3,i5)))
    faces.append(Face3D(material=materials[currmaterial],vertices=(i2,i6,i4)))
    p1,p2,p3,p4 = p4,p3,p6,p5
    i1,i2,i3,i4 = i4,i3,i6,i5
    for tt in range(t): 
      p1,p2,p4,p3 = p2,p4,p3,p1
      i1,i2,i4,i3 = i2,i4,i3,i1
    posx,posy,posz = rubiksnakecode.move(posx,posy,posz,dir1)
    dir1,dir2,dir3 = rubiksnakecode.turn(dir1,dir2,dir3,t)
    currmaterial = 1 - currmaterial
  p5 = Coordinate(rubiksnakecode.move(p3.x,p3.y,p3.z,dir2))
  p6 = Coordinate(rubiksnakecodeg.move(p4.x,p4.y,p4.z,dir2))
  i5, i6 = len(vertices), len(vertices) + 1
  vertices += (p5,p6)
  faces.append(Face3D(material=materials[currmaterial],vertices=(i1,i5,i6,i2)))
  faces.append(Face3D(material=materials[currmaterial],vertices=(i1,i3,i5)))
  faces.append(Face3D(material=materials[currmaterial],vertices=(i2,i6,i4)))
  faces.append(Face3D(material=materials[currmaterial],vertices=(i3,i4,i6,i5)))
  for v in vertices: 
    v.x *= r.size
    v.y *= r.size
    v.z *= r.size
  o = Object3D(vertices=vertices,faces=faces,material="rubiksnake_white",axis=r.axis)
  return o

spyder.core.defineconverter("RubikSnake","Object3D",spyderconverterfunction_13)

del spyderconverterfunction_13
